SystemOrganization addCategory: #'Ma object serialization-API'!
SystemOrganization addCategory: #'Ma object serialization-Info'!
SystemOrganization addCategory: #'Ma object serialization-exceptions'!
SystemOrganization addCategory: #'Ma object serialization-private'!
SystemOrganization addCategory: #'Ma object serialization-support'!

!BlockContext class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:14'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	^ (aMaObjectSerializer materializeGraph: aByteArray) asBlockContext! !

!BlockContext methodsFor: '*ma object serialization' stamp: 'cmm 11/10/2004 12:01'!
maAsStorageObject

	^ MaBlockContextStorage newFor: self! !

!LargePositiveInteger class methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 23:56'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ aMaByteObjectBuffer asByteObject: self! !

!Dictionary class methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 12:35'!
maLoadVariableObjectFrom: aMaVariableObjectBuffer
	| skeleton |
	skeleton _ self new: aMaVariableObjectBuffer objectInstSize / 2. "key + value"
	1
		to: aMaVariableObjectBuffer objectInstSize
		by: 2
		do:
			[ :index |
			skeleton
				at: (aMaVariableObjectBuffer maInstVarAt: index)
				put: (aMaVariableObjectBuffer maInstVarAt: index + 1) ].
	^ skeleton! !

!Dictionary methodsFor: '*ma object serialization' stamp: 'cmm 12/11/2008 10:22'!
maBufferInstSize
	^ (self size * 2) + "enough for other named instVars" self maInstSize - 2 "except tally and array"! !

!Dictionary methodsFor: '*ma object serialization' stamp: 'cmm 3/27/2006 17:00'!
maEstablishPointerReferencesUsing: aMaObjectSerializer
	| transformer fullOfOidsCopy |
	self isEmpty ifTrue: [ ^ self ]. "performance"
	transformer _ [ :object | (aMaObjectSerializer objectWithOid: object) ].
	fullOfOidsCopy _ self copy.
	self maRemoveAll.
	fullOfOidsCopy keysAndValuesDo:
		[ :eachKey :eachValue |
		self
			at: (transformer value: eachKey)
			put: (transformer value: eachValue) ]! !

!Dictionary methodsFor: '*ma object serialization' stamp: ''!
maIsHashedCollection

	^true
! !

!Dictionary methodsFor: '*ma object serialization' stamp: 'cmm 11/28/2004 16:20'!
maStreamVariablyInto: aMaVariableObjectBuffer for: aMaObjectSerializer
	"Put the receivers instance variables into aMaVariableObjectBuffer."

	| index |
	index _ 1.
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		[ : obj |
			aMaVariableObjectBuffer
				maInstVarAt: index
				put: (aMaObjectSerializer oidFor: obj).
			index _ index + 1 ]
				value: eachKey;
				value: eachValue ].
	"Now take care of additional named variables."
	3 "skip array and tally, they're taken care of logically, above."
		to: self maInstSize
		do:
			[ : namedIndex |
			aMaVariableObjectBuffer
				maInstVarAt: index + namedIndex
				put: (aMaObjectSerializer oidFor: (self instVarAt: namedIndex)) ]! !

!WriteStream methodsFor: '*ma object serialization' stamp: 'cmm 4/12/2009 20:15'!
maBuffersDo: aBlock 
	[ self maNextBufferDo: aBlock ] whileTrue! !

!WriteStream methodsFor: '*ma object serialization' stamp: 'cmm 6/8/2009 15:45'!
maNextBufferDo: aBlock 
	| remainingBytes header record recordSize |
	remainingBytes := self size - self position.
	remainingBytes < 4 ifTrue: [ ^ false ].
	header := self next: 4.
	self position: self position - 4.
	recordSize := header 
		maUint: MaSerializedGraphBuffer headerSize * 8
		at: 0.
	recordSize = 0 ifTrue: 
		[ "Normally, this shouldn't happen, but when loading from a ZipArchive member, someone changed it to come in from a MultiByteBinaryOrTextStream, which is not 100% compatible with StandardFileStream.  In some cases we end up with zero-bytes on the end of the file.."
		^ false ].
	remainingBytes >= recordSize ifFalse: [ ^ false ].
	record := self next: recordSize.
	aBlock value: record.
	^ true! !

!Bitmap class methodsFor: '*ma object serialization' stamp: 'cmm 5/3/2005 11:44'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	| compressedByteArray |
	compressedByteArray _ aMaObjectSerializer materializeGraph: aByteArray.
	^ self decompressFromByteArray: compressedByteArray! !

!Bitmap methodsFor: '*ma object serialization' stamp: 'cmm 11/7/2004 22:54'!
maAsStorageObject

	^ self compressToByteArray! !

!Bitmap methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:00'!
maUsesStandardStorage

	^ false! !

!SystemWindow methodsFor: '*ma object serialization' stamp: 'cmm 2/22/2005 12:49'!
maTransientVariables

	^ super maTransientVariables, #( 'owner' )! !

!ProcessorScheduler class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:16'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	^ Processor! !

!ProcessorScheduler methodsFor: '*ma object serialization' stamp: 'cmm 12/19/2002 23:13'!
maAsStorageObject
	"We don't even need to store the name of the global.  It's class
	gives it away."

	^String maEmpty
! !

!ProcessorScheduler methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!EventSensor class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:15'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"If I was the Sensor global, then I was stored as an empty String in a MaByteObjectBuffer and, thus, got to this method.  Otherwise, we materialize standard through the fixed-buffer."

	^ Sensor! !

!EventSensor methodsFor: '*ma object serialization' stamp: 'cmm 2/6/2005 17:21'!
maAsStorageObject 

	^ self == Sensor
		ifTrue: [ String maEmpty ]
		ifFalse: [ self ]! !

!EventSensor methodsFor: '*ma object serialization' stamp: 'cmm 2/6/2005 16:57'!
maUsesStandardStorage

	^ self ~~ Sensor! !

!Metaclass class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 14:22'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	^ (Class
		maMaterializeFromGraph: aByteArray
		using: aMaObjectSerializer) class! !

!Metaclass methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 22:57'!
maInstancesRequireOwnBuffer

	^ true! !

!Metaclass methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 22:53'!
maSerializationClass

	^ Metaclass! !

!Array class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:13'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"This method exists to mirror the logic in Array>>#objectForDataStream, whereby if the Array being stored is one of two special global Array's, a DiskProxy is stored instead.  For Ma object serialization, this was done on my instance-side in #maAsStorageObject.  If I was not stored as the DiskProxy, then I would not get to this method."

	| diskProxy |
	diskProxy _ aMaObjectSerializer materializeGraph: aByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!Array methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 23:27'!
maAsStorageObject
	"I am about to be written on an object file.  If I am one of two shared global arrays, write a proxy instead."

	"Note this behavior copied from Array>>#objectForDataStream:."
	self == (TextConstants at: #DefaultTabsArray)
		ifTrue: [ ^ DiskProxy global: #TextConstants selector: #at: args: #(DefaultTabsArray) ].
	self == (TextConstants at: #DefaultMarginTabsArray)
		ifTrue: [ ^ DiskProxy global: #TextConstants selector: #at: args: #(DefaultMarginTabsArray) ].
	^ super maAsStorageObject! !

!Array methodsFor: '*ma object serialization' stamp: 'cmm 6/27/2005 15:12'!
maUsesStandardStorage

	^ self ~~ (TextConstants at: #DefaultTabsArray)
	and: [ self ~~ (TextConstants at: #DefaultMarginTabsArray) ]! !

!ScreenController class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:16'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"This method exists to mirror the logic in my instance-side #objectForDataStream:.  We use a reference in this materializing image rather than the creating a new object."

	| diskProxy |
	diskProxy _ aMaObjectSerializer materializeGraph: aByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!ScreenController methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:01'!
maAsStorageObject
	"Like DataStream, just store a reference to me instead of me."

	^ DiskProxy
		global: #ScheduledControllers
		selector: #screenController args: #()! !

!ScreenController methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:00'!
maUsesStandardStorage 
	^ false! !

!StrikeFontSet class methodsFor: '*ma object serialization' stamp: 'cmm 8/24/2005 16:23'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"Materialize the DiskProxy which computes a reference to an appropriate StrikeFont in this materializing system."

	| diskProxy |
	diskProxy := aMaObjectSerializer materializeGraph: aByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!StrikeFontSet methodsFor: '*ma object serialization' stamp: 'cmm 8/24/2005 16:21'!
maAsStorageObject 

	^ DiskProxy
		global: #StrikeFont selector: #familyName:size:emphasized:
		args: { self familyName.  self height.  self emphasis }! !

!StrikeFontSet methodsFor: '*ma object serialization' stamp: 'cmm 8/24/2005 16:22'!
maUsesStandardStorage 

	^ false! !

!TTCFont methodsFor: '*ma object serialization' stamp: 'cmm 8/5/2008 12:55'!
maAsStorageObject
	"I am about to be written on an object file.  Write a
reference to a known FontSet in the other system instead."
	"a path to me"
	^ DiskProxy 
		global: #TTCFont
		selector: #familyName:pointSize:emphasis:
		args: { 
				(self familyName).
				(self pointSize).
				(self emphasis)
			 }! !

!TTCFont methodsFor: '*ma object serialization' stamp: 'cmm 8/5/2008 12:55'!
maUsesStandardStorage 

	^ false! !

!TTCFont methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 22:43'!
maWantsPreSerialization 
	^ true! !

MaObject subclass: #MaBlockContextStorage
	instanceVariableNames: 'nargs startpc home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaBlockContextStorage class methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:11'!
newFor: aBlockContext

	^ self new
		initializeFrom: aBlockContext ;
		yourself! !

!MaBlockContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:07'!
asBlockContext

	| methodContext |
	methodContext _ home asMethodContext.
	^ (BlockContext newForMethod: methodContext method)
		home: methodContext
		startpc: startpc
		nargs: nargs! !

!MaBlockContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:12'!
initializeFrom: aBlockContext

	nargs _ aBlockContext numArgs.
	startpc _ aBlockContext startpc.
	home _ MaMethodContextStorage newFor: aBlockContext home! !

MaObject subclass: #MaBufferPositionMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaBufferPositionMap commentStamp: 'cmm 8/26/2008 02:36' prior: 0!
This is an abstraction for the attributes available on a MaObjectBuffer.  Subclasses may override and extend.!

!MaBufferPositionMap class methodsFor: 'as yet unclassified' stamp: 'cmm 8/27/2008 14:31'!
bufferPositionOfClassVersion
	"Zero-based position."
	^ 12! !

!MaBufferPositionMap class methodsFor: 'as yet unclassified' stamp: 'cmm 8/27/2008 14:31'!
headerSize
	"The standard record has 14 bytes of header."
	^ 14! !

!MaBufferPositionMap class methodsFor: 'as yet unclassified' stamp: 'cmm 8/27/2008 20:53'!
indexPosition
	"Reserve the 0-based particular slot for this attribute map."
	^ 0! !

MaObject subclass: #MaClassIdManager
	instanceVariableNames: 'classesById idsByClass nextClassId classDefinitionsById inImageDefinitions minimumClasses mutable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaClassIdManager commentStamp: 'cmm 6/11/2004 16:53' prior: 0!
classDefinitionsById -- all versions of all classes that I know about
 inImageDefinitions -- the in-image version of each class I know about.!

!MaClassIdManager class methodsFor: 'accessing' stamp: 'cmm 12/30/2008 15:25'!
minimumClasses
	"These are the classes required to transmit a MaClassDefinition, used to establish protocol between two images."
	^ { Metaclass.  Class.  MaClassReference.  MaClassDefinition.
	"These atomic types are needed for backward compatibility with version 8."
	Boolean. SmallInteger. Character. Float. UndefinedObject.
	Array. #size class. '' class. ByteArray. Set.  OrderedCollection. Dictionary.
	"Added these at the end for backward compatibility.  Boolean was not the right one, you need the exact classes!!"
	True. False } ! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 1/29/2009 22:18'!
addClassDefinition: aMaClassDefinition

	| definitions answer |
	definitions _ self ensureClassDefinitionsFor: aMaClassDefinition.
	(answer _ self definitionLike: aMaClassDefinition in: definitions)
		ifNil:
			[ answer _ aMaClassDefinition.
			definitions add: aMaClassDefinition.
			aMaClassDefinition version: definitions size ].
	answer isDefined ifTrue:
		[ self
			idOfClass: answer classObject
			is: answer id.
		self refreshInImageDefinition: answer classObject.
		(answer superclassDefinition isNil and: [ answer classObject superclass ~= nil ])
			ifTrue:
				[ self addNewClass: answer classObject superclass.
				answer initializeSuperclassDefinitionUsing: self ] ].
	^ answer! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 10/17/2004 22:38'!
addNewClass: aClass
	"Answer the storage definition created for aClass."

	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ self addClassDefinition: (MaClassDefinition className: aClass name)! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 8/23/2007 16:25'!
beImmutable
	mutable _ false! !

!MaClassIdManager methodsFor: 'accessing' stamp: ''!
classDefinitionsById

	^classDefinitionsById
! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 6/29/2004 17:42'!
classDefinitionsById: aDictionary

	classDefinitionsById _ aDictionary! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/17/2004 22:39'!
classDefinitionsForClass: aClass

	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ self classDefinitionsForId: (self idForClass: aClass)! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 8/22/2005 09:23'!
classDefinitionsForId: anInteger

	^ self
		classDefinitionsForId: anInteger
		ifAbsent: [ MaObjectSerializationSoftwareError signal: 'class-definition not found' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/12/2004 22:16'!
classDefinitionsForId: anInteger ifAbsent: aBlock

	^ anInteger
		ifNil: [ aBlock value ]
		ifNotNil:
			[ classDefinitionsById
				at: anInteger
				ifAbsent: aBlock ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/8/2004 16:13'!
classForId: anInteger

	^ self
		classForId: anInteger
		ifAbsent: [ self error: anInteger printString, ' is not a known class id.' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 7/11/2005 12:46'!
classForId: anInteger ifAbsent: aBlock

	^ anInteger <= minimumClasses size
		ifTrue:
			[ minimumClasses at: anInteger ]
		ifFalse:
			[ classesById
				at: anInteger
				ifAbsent: aBlock ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/17/2004 22:39'!
currentVersionOfClass: aClass

	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ (self
		inImageDefinition: aClass
		ifAbsent: [ ^ 1 ]) version! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 3/23/2005 13:25'!
definitionForClassId: classIdInteger version: classVersionInteger

	^ classVersionInteger = 0
		ifTrue: [ self inImageDefinition: (self classForId: classIdInteger) ]
		ifFalse: [ (self classDefinitionsForId: classIdInteger) at: classVersionInteger ]! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 10/13/2004 23:43'!
definitionLike: aMaClassDefinition in: definitionsCollection

	definitionsCollection isEmpty ifTrue: [ ^ nil ].
	(definitionsCollection anySatisfy: [ : each | each className = aMaClassDefinition className ]) ifFalse: [ ^ nil ].
	(definitionsCollection includes: aMaClassDefinition) ifTrue: [ ^ aMaClassDefinition ].
	^ definitionsCollection 
		detect: [ : eachDef | eachDef hasSameDefinitionAs: aMaClassDefinition ]
		ifNone: [ nil ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/14/2004 09:42'!
ensureClassDefinitionsFor: aMaClassDefinition
	"Look for the collection of versions of the same class that aMaClassDefinition is for.  If none exist create and answer the new collection that will hold aMaClassDefinition and its future versions."

	^ (aMaClassDefinition id notNil and: [ classDefinitionsById includesKey: aMaClassDefinition id ])
		ifTrue: [ classDefinitionsById at: aMaClassDefinition id ]
		ifFalse:
			[ classDefinitionsById 
				maDetect: [ : eachDefinitions | eachDefinitions anySatisfy: [ : each | each isKnownAs: aMaClassDefinition className ] ]
				ifFound:
					[ : foundDefinitions | 
					aMaClassDefinition id: foundDefinitions first id.
					foundDefinitions ]
				ifNone:
					[ "None found, let's create one."
					| id class |
					"First figure out the id."
					id _ aMaClassDefinition hasId
						ifTrue: [ aMaClassDefinition id ]
						ifFalse:
							[ "Make sure not one of the minimumClasses."
							((Smalltalk hasClassNamed: aMaClassDefinition className) and: [ self isMemberOfMinimumClasses: (class _ Smalltalk at: aMaClassDefinition className) ])
								ifTrue: [ self idForClass: class ]
								ifFalse: [ self nextClassId ] ].
					aMaClassDefinition id: id.
					classDefinitionsById
						at: id
						put: (OrderedCollection new: 1) ] ]! !

!MaClassIdManager methodsFor: 'event handling' stamp: 'cmm 10/1/2004 15:21'!
handleClassModification: aClass using: aMaObjectSerializer

	"Optional subclass hook."! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 10/15/2004 12:31'!
hasClassDefinitionFor: aClass

	| foundQuickly |
	foundQuickly _ inImageDefinitions
		maAt: aClass
		ifPresent: [ : definition | definition isPartOfClassDefinitions ]
		ifAbsent: [ false ].
	^ foundQuickly or:
		[ classDefinitionsById anySatisfy:
			[ : eachDefinitions |
			(eachDefinitions last isKnownAs: aClass name)
			and: [ eachDefinitions
				anySatisfy:
					[ : each | each hasSameDefinitionAs: aClass ] ] ] ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 8/26/2002 22:03'!
idForClass: aClass

	^self
		idForClass: aClass
		ifAbsent: [ MaSoftwareError signal: aClass name, ' has no id assigned.' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 7/20/2007 11:52'!
idForClass: aClass ifAbsent: aBlock 
	| index |
	aClass isMeta ifTrue: 
		[ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ idsByClass 
		at: aClass
		ifAbsent: 
			[ (index _ minimumClasses indexOf: aClass) > 0 
				ifTrue: [ index ]
				ifFalse: [ aBlock value ] ]! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 12/18/2008 15:15'!
idOfClass: aClass is: anInteger 
	mutable ifFalse: 
		[ (classesById includesKey: anInteger) ifFalse: 
			[ MaObjectSerializationUserError signal: '#protocol extension not allowed (' , aClass printString , ').' ] ].
	nextClassId := nextClassId max: anInteger.
	classesById 
		at: anInteger
		put: aClass.
	^ idsByClass 
		at: aClass
		put: anInteger! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/6/2004 19:46'!
inImageDefinition: aClass

	^ self
		inImageDefinition: aClass
		ifAbsent: [ self error: aClass name, ' is not part of my inImageDefinitions.' ]! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 10/15/2004 11:58'!
inImageDefinition: aClass ifAbsent: aBlock

	^ inImageDefinitions
		at: (aClass isMeta ifTrue: [ Metaclass ] ifFalse: [ aClass ])
		ifAbsent: aBlock! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 6/30/2004 00:03'!
includesIdForClass: aClass

	^ idsByClass includesKey: aClass! !

!MaClassIdManager methodsFor: 'copy' stamp: 'cmm 3/24/2005 12:06'!
independentCopy

	^ self copy postIndependentCopy! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 3/16/2009 20:29'!
initialClassId
	^ 100! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 3/16/2009 20:29'!
initialize
	super initialize.
	idsByClass := Dictionary new.
	classesById := Dictionary new.
	nextClassId := self initialClassId.
	inImageDefinitions := Dictionary new.
	mutable := true.
	self classDefinitionsById: Dictionary new.
	self initializeMinimumClasses! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 7/11/2005 12:45'!
initializeMinimumClasses

	minimumClasses _ self class minimumClasses.
	minimumClasses do: [ : each | self addNewClass: each ]! !

!MaClassIdManager methodsFor: 'testing' stamp: 'cmm 7/11/2005 12:46'!
isMemberOfMinimumClasses: aClass
	aClass isMeta ifTrue: [ MaObjectSerializationSoftwareError signal: 'Metaclass instances are not stored here.' ].
	^ minimumClasses includes: aClass! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 2/25/2008 16:36'!
isMutable
	^ mutable! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 7/11/2005 12:46'!
minimumClasses

	^ minimumClasses! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 8/15/2002 23:53'!
nextClassId

	^nextClassId _ nextClassId + 1
! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 7/11/2005 14:38'!
numberOfClasses

	^ classDefinitionsById size! !

!MaClassIdManager methodsFor: 'private' stamp: 'cmm 3/24/2005 12:05'!
postIndependentCopy

	classesById _ classesById copy.
	idsByClass _ idsByClass copy.
	classDefinitionsById _ classDefinitionsById copy.
	inImageDefinitions _ inImageDefinitions copy! !

!MaClassIdManager methodsFor: 'accessing' stamp: 'cmm 3/16/2009 20:43'!
protocol
	"Calculate and answer the protocol based on assigned classId's (which, because superclasses are added, may not match the original protocol set).  This is used for fileingout a single object, the user is not burdened with protocol, it is calculated and stored with the object."
	^ ((self classDefinitionsById select: [ : each | each anyOne id > self initialClassId ]) asSortedCollection: [ : a : b | a anyOne id < b anyOne id ]) collect: [ : each | each anyOne classObject ]! !

!MaClassIdManager methodsFor: 'building' stamp: 'cmm 1/16/2005 22:16'!
refreshInImageDefinition: aClass
	"Whenever the user recompiles a class in the image (e.g., during development)."

	({ Object. ProtoObject } includes: aClass)
		ifTrue:
			[ (self hasClassDefinitionFor: aClass)
				ifTrue:
					[ inImageDefinitions
						at: aClass
						ifAbsentPut: [ (self classDefinitionsForClass: aClass) last ].
			^ self  "performance" ] ].
	aClass withAllSubclassesDo:
		[ : eachClass |  	| knownDefinitions |
		(eachClass = aClass or: [ self includesIdForClass: eachClass ])
			ifTrue:
				[ knownDefinitions _ (self hasClassDefinitionFor: eachClass)
					ifTrue: [ self classDefinitionsForClass: eachClass ]
					ifFalse: [ #() ].
				inImageDefinitions
					at: eachClass
					put:
						(knownDefinitions
							maDetect: [ : each | each hasSameDefinitionAs: eachClass ]
							ifFound:
								[ : foundDef |
								"In the rare case, where a classdef was materialized but not defined in the image, so it was added to definitions only.  Now we're defining it so we need to be sure we set up its mappings."
								self
									idOfClass: eachClass
									is: foundDef id.
								foundDef ]
							ifNone: [ MaClassDefinition className: eachClass name ]) ] ]! !

MaObject subclass: #MaCompiledMethodStorage
	instanceVariableNames: 'header literals startPc endPc byteCodes sourcePointer className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaCompiledMethodStorage class methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:12'!
newFor: aCompiledMethod

	^ self new
		initializeFrom: aCompiledMethod ;
		yourself! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 8/6/2007 09:24'!
asCompiledMethod

	| answer |
	answer _ 
		CompiledMethod 
			newMethod: endPc - startPc + 1 + 4
			header: header.
	literals withIndexDo: 
		[ : each : index |
		answer
			literalAt: index
			put: each ].
"	answer setSourcePointer: sourcePointer."  "<-- don't restore it, it could be wrong."
"In fact..."
sourcePointer > 0 ifTrue: [ answer zapSourcePointer ].
	answer
		replaceFrom: startPc
		to: endPc
		with: byteCodes
		startingAt: 1.
	self restoreLiterals: answer.
	MaObject isPre3dot9 ifFalse: [ answer maFixUpPragmas ].
	^ answer! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 8/6/2007 09:28'!
cleanLiterals: aCompiledMethod 
	"Strip class-var objects from anArray (nil them out).  Class vars are not stored, but we will try to hook them up by name upon materialization."
	| answer |
	answer _ aCompiledMethod literals.
	answer withIndexDo: 
		[ : eachLiteral : index | 
		((eachLiteral respondsTo: #isMethodProperties) and: [ eachLiteral isMethodProperties ]) 
			ifTrue: 
				[ answer 
					at: index
					put: eachLiteral maCopyWithDisconnectedPragmas ]
			ifFalse: 
				[ (eachLiteral isVariableBinding and: 
					[ eachLiteral isSpecialWriteBinding not and: 
						[ eachLiteral key notNil and: [ (Smalltalk includesKey: eachLiteral key) not ] ] ]) ifTrue: 
					[ answer 
						at: index
						put: eachLiteral copy.
					(answer at: index) value: nil ] ] ].
	^ answer! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 12/2/2008 23:24'!
initializeFrom: aCompiledMethod 
	className := aCompiledMethod methodClass name.
	literals := self cleanLiterals: aCompiledMethod.
	header := aCompiledMethod header.
	sourcePointer := aCompiledMethod sourcePointer.
	startPc := aCompiledMethod initialPC.
	endPc := aCompiledMethod endPC.
	byteCodes := ByteArray new: endPc - startPc + 1.
	byteCodes 
		replaceFrom: 1
		to: byteCodes size
		with: aCompiledMethod
		startingAt: startPc! !

!MaCompiledMethodStorage methodsFor: 'as yet unclassified' stamp: 'cmm 2/22/2005 10:05'!
restoreLiterals: aCompiledMethod
	"This method attempts to logically restore any reference to class-vars in aCompiledMethod.  Even though aCompiledMethod is not installed in the system, I saved its class and selector during serialization, now I can use that information to, if present, re-hook up the class variable up to the one in this image." 

	aCompiledMethod literals withIndexDo:
		[ : eachLiteral : index |
		(eachLiteral isVariableBinding
		and: [ eachLiteral isSpecialWriteBinding not ])
			ifTrue:
				[ | methodClass classVarNames classBinding |
				methodClass _ Smalltalk at: className ifAbsent: [ nil ].
				classBinding _ (eachLiteral key notNil and: [ methodClass notNil and: [ methodClass allClassVarNames includes: eachLiteral key ] ])
					ifTrue: [ methodClass bindingOf: eachLiteral key ]
					ifFalse:
						[ "Ok, not a class-var (at least not any more), check to see if its a Smalltalk global."
						(eachLiteral key notNil and: [ (Smalltalk includesKey: eachLiteral key) not ])
							ifTrue:
								[ ^ MaObjectSerializationWarning signal: 'Warning, cannot remap ', className, '>>''', eachLiteral key asString, ''' because that global is no longer defined.  nil will be substituted.' ].
						eachLiteral ].
				aCompiledMethod
					literalAt: index
					put: classBinding ] ]! !

MaObject subclass: #MaGlobalReference
	instanceVariableNames: 'globalName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

MaGlobalReference subclass: #MaClassReference
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

MaClassReference subclass: #MaClassDefinition
	instanceVariableNames: 'instVarNames version superclassDefinition category type comment commentStamp classVarNames poolDictionaryNames classInstVarNames aliases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaClassDefinition class methodsFor: 'creation' stamp: 'cmm 6/16/2004 11:26'!
className: aSymbol

	^(super className: aSymbol)
		initializeFrom: (Smalltalk classNamed: aSymbol) ;
		yourself! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 12/19/2002 21:45'!
allInstVarNames
	^instVarNames! !

!MaClassDefinition methodsFor: 'actions' stamp: 'cmm 1/26/2005 13:06'!
allSuperclassDefinitionsDo: oneArgBlock
	"Value oneArgBlock with each of my superclass-definitions, in turn."

	superclassDefinition ifNotNil: [ superclassDefinition withAllSuperclassDefinitionsDo: oneArgBlock ]! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:38'!
classInstanceVariablesString
	^ self stringForVariables: classInstVarNames! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 10/13/2004 23:52'!
className: newClassName

	self className ifNotNil: [ aliases add: self className ].
	super className: newClassName! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:37'!
classVariablesString
	^ self stringForVariables: classVarNames! !

!MaClassDefinition methodsFor: 'actions' stamp: 'cmm 3/8/2005 13:51'!
createClassUsing: aMaObjectSerializer
	| superClass |
	superClass _ self superclassDefinition ensureClassUsing: aMaObjectSerializer.
	^ SystemChangeNotifier uniqueInstance doSilently:
		[ ((ClassBuilder new)
			name: self className
			inEnvironment: superClass environment 
			subclassOf: superClass
			type: type 
			instanceVariableNames: self instanceVariablesString 
			classVariableNames: self classVariablesString 
			poolDictionaries: self sharedPoolsString
			category: category)
			
			ifNotNilDo:
				[ : class |
				aMaObjectSerializer classIdManager
					idOfClass: class
					is: self id.
				class class instanceVariableNames: self classInstanceVariablesString.
				class hasComment
					ifTrue: 
						[ class 
							classComment: comment 
							stamp: commentStamp ].
				aMaObjectSerializer classIdManager refreshInImageDefinition: class.
				class ] ]! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 10/27/2004 23:34'!
ensureClassUsing: aMaObjectSerializer

	^ self isDefined
		ifTrue: [ self classObject ]
		ifFalse: [ self createClassUsing: aMaObjectSerializer ]! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 10/13/2004 16:44'!
hasSameDefinitionAs: aClassOrMaClassDefinition

	^ self allInstVarNames maMatchesElementsOf: aClassOrMaClassDefinition allInstVarNames! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 6/16/2004 22:40'!
indexOfInstVarCorrespondingTo: instVarIndex of: anotherMaClassDefinition
	"Answer the index of the instVar in me that corresponds to the one at instVarIndex in anotherMaClassDefinition."

	self == anotherMaClassDefinition ifTrue: [ ^ instVarIndex ].
	"different versions, determine if instVarIndex refers to a named or indexed var"
	^ instVarIndex > anotherMaClassDefinition allInstVarNames size
		ifTrue:
			[ "indexed inst var" 
			self allInstVarNames size + (instVarIndex - anotherMaClassDefinition allInstVarNames size) ]
		ifFalse:
			[ "find the instVar with the same name."
			self allInstVarNames
				indexOf: (anotherMaClassDefinition allInstVarNames at: instVarIndex) ]! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 10/13/2004 23:50'!
initialize

	super initialize.
	self version: 0.
	aliases _ OrderedCollection new! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 6/10/2004 23:43'!
initializeFrom: aClass

	self globalName: aClass name.
	instVarNames _ aClass allInstVarNames.
	classVarNames _ aClass classVarNames.
	poolDictionaryNames _ aClass poolDictionaryNames.
	classInstVarNames _ aClass class instVarNames.
	category _ aClass category.
	type _ aClass typeOfClass.
	comment _ aClass organization classComment asString.
	commentStamp _ aClass organization commentStamp! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 6/11/2004 00:33'!
initializeSuperclassDefinitionUsing: aMaClassIdManager

	| superclassDefinitions |
	superclassDefinitions _ aMaClassIdManager classDefinitionsForClass: self classObject superclass.
	superclassDefinition _
		superclassDefinitions
			detect: [ : each | each hasSameDefinitionAs: self classObject superclass ]
			ifNone: [ aMaClassIdManager inImageDefinition: self classObject superclass ]! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 10/13/2004 13:03'!
instanceVariablesString

	^ self stringForVariables: (instVarNames copyWithoutAll: superclassDefinition allInstVarNames)! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 6/8/2004 15:58'!
isDefined

	^ Smalltalk hasClassNamed: self className! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 10/13/2004 23:53'!
isKnownAs: className

	^ self name = className
	or: [ aliases includes: className ]! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 6/7/2004 21:35'!
isPartOfClassDefinitions

	^ version > 0! !

!MaClassDefinition methodsFor: 'printing' stamp: 'cmm 6/24/2004 14:42'!
maPrintAbbreviatedOn: aStream

	super maPrintAbbreviatedOn: aStream.
	self
		maPrintAttribute: #version
		on: aStream! !

!MaClassDefinition methodsFor: 'testing' stamp: 'cmm 11/26/2004 15:12'!
maWantsPostMaterialization
	^ true! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/2/2005 15:21'!
maWantsPreSerialization
	^ false! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 12/19/2002 21:43'!
namedInstSize
	^self allInstVarNames size! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:35'!
sharedPoolsString
	^ self stringForVariables: poolDictionaryNames! !

!MaClassDefinition methodsFor: 'private' stamp: 'cmm 5/18/2004 00:34'!
stringForVariables: aCollection

	^ String streamContents:
		[ :stream |
		aCollection
			do: [ :ea | stream nextPutAll: ea ]
			separatedBy: [ stream space ] ]! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 6/11/2004 00:55'!
superclassDefinition

	^ superclassDefinition! !

!MaClassDefinition methodsFor: 'accessing' stamp: 'cmm 6/10/2004 23:49'!
superclassName

	^ superclassDefinition className! !

!MaClassDefinition methodsFor: 'accessing' stamp: ''!
version

	^version! !

!MaClassDefinition methodsFor: 'building' stamp: 'cmm 6/23/2004 13:49'!
version: anInteger

	version _ anInteger
! !

!MaClassDefinition methodsFor: 'actions' stamp: 'cmm 10/17/2004 15:04'!
withAllSuperclassDefinitionsDo: oneArgBlock
	"Value oneArgBlock with myself, then each of my superclass-definitions, in turn."

	oneArgBlock value: self.
	superclassDefinition ifNotNil: [ superclassDefinition withAllSuperclassDefinitionsDo: oneArgBlock ]! !

!MaClassReference class methodsFor: 'creation' stamp: 'cmm 6/28/2004 18:05'!
className: aSymbol

	^ self globalName: aSymbol! !

!MaClassReference methodsFor: 'accessing' stamp: ''!
className

	^self globalName
! !

!MaClassReference methodsFor: 'building' stamp: ''!
className: aSymbol

	self globalName: aSymbol
! !

!MaClassReference methodsFor: 'accessing' stamp: ''!
classObject

	^self globalObject
! !

!MaClassReference methodsFor: 'accessing' stamp: 'cmm 6/23/2004 00:03'!
hasId

	^ self id notNil! !

!MaClassReference methodsFor: 'accessing' stamp: ''!
id

	^id
! !

!MaClassReference methodsFor: 'building' stamp: ''!
id: anInteger

	id _ anInteger
! !

!MaClassReference methodsFor: 'private' stamp: 'cmm 5/2/2005 15:20'!
maWantsPreSerialization
	^ true! !

!MaClassReference methodsFor: 'accessing' stamp: 'cmm 1/1/2003 23:52'!
name
	"For interface compatibility with Class."

	^self className! !

!MaGlobalReference class methodsFor: 'creation' stamp: ''!
globalName: aSymbol

	^self new globalName: aSymbol
! !

!MaGlobalReference methodsFor: 'private' stamp: ''!
globalName

	^globalName! !

!MaGlobalReference methodsFor: 'private' stamp: ''!
globalName: aSymbol

	globalName _ aSymbol
! !

!MaGlobalReference methodsFor: 'accessing' stamp: 'cmm 6/28/2004 14:29'!
globalObject

	^Smalltalk
		at: self globalName
		ifAbsent:
			[ MaObjectSerializationSoftwareError signal: self globalName, ' not defined in this image.'.
			self ]! !

!MaGlobalReference methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: self globalName
! !

MaObject subclass: #MaMethodContextStorage
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-private'!

!MaMethodContextStorage class methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:11'!
newFor: aMethodContext

	^ self new
		initializeFrom: aMethodContext ;
		yourself! !

!MaMethodContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/12/2004 16:37'!
asMethodContext

	| cm |
	^ (MethodContext newForMethod: (cm _ method asCompiledMethod))
		privRefreshWith: cm ;
		yourself! !

!MaMethodContextStorage methodsFor: 'as yet unclassified' stamp: 'cmm 11/9/2004 15:14'!
initializeFrom: aMethodContext

	method _ MaCompiledMethodStorage newFor: aMethodContext method! !

MaObject subclass: #MaObjectBuffer
	instanceVariableNames: 'byteArray startPos'
	classVariableNames: 'BufferClasses BufferPositionMaps'
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaObjectBuffer commentStamp: 'cmm 8/26/2008 02:21' prior: 0!
This class encapsulates a single object into its byteArray.  The 0-based buffer positions of my fields are:

	0 = oid (6 bytes)
	6 = physicalSize (3 bytes)
	9 = control-fields (1 byte)
		4 bits (low-order) = bufferType (logical-type indicator of one of my subclasses)
		4 bits (high-order) = indexed position into my class' #bpMaps Array, this value 0-15 (so +1 for access), the attribute-map Dictionary, mapping each attribute Symbol (i.e., #oid) to its bufferPosition.  This allows advanced users like Magma add fields add its fields without interfering into the simpler nature of Ma object serialization.
		bpMaps:
			at: 0 = Ma object serialization minimum.
			at: 1 = Magma-added fields
	10 = classId (2 bytes)!

MaObjectBuffer subclass: #MaFixedObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaFixedObjectBuffer commentStamp: 'cmm 4/26/2005 08:13' prior: 0!
This class encapsulates an object that has a fixed-size.  Most objects are fixed-size.  My 0-based buffer fields are:

	(see superclass)
	12 = classVersion (2 bytes)!

!MaFixedObjectBuffer methodsFor: 'private' stamp: 'cmm 8/25/2008 22:14'!
bufferPositionOfClassVersion
	^ self bpMap bufferPositionOfClassVersion! !

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:32'!
bufferType
	^ 3! !

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 22:05'!
classVersion

	^self 
		uint: 16
		at: self bufferPositionOfClassVersion
! !

!MaFixedObjectBuffer methodsFor: 'accessing' stamp: 'cmm 10/21/2004 22:05'!
classVersion: anInteger

	self
		uint: 16
		at: self bufferPositionOfClassVersion
		put: anInteger
! !

!MaFixedObjectBuffer methodsFor: 'creation' stamp: 'cmm 12/2/2004 12:35'!
createObjectUsing: aMaObjectSerializer
	| class skeleton indexedSize sourceDefinition inImageDefinition |
	class _ self ensureClassUsing: aMaObjectSerializer.
	sourceDefinition _ 
		aMaObjectSerializer classIdManager
			definitionForClassId: self classId
			version: self classVersion.
	inImageDefinition _ aMaObjectSerializer classIdManager inImageDefinition: class.
	indexedSize _ self objectInstSize - sourceDefinition namedInstSize.
	skeleton _ indexedSize = 0 ifTrue: [ class basicNew ] ifFalse: [ class basicNew: indexedSize ].
	self instVarsDoWithIndex:
		[ : eachOid : sourceIndex |  | targetIndex |
		targetIndex _
			inImageDefinition
				indexOfInstVarCorrespondingTo: sourceIndex
				of: sourceDefinition.
		targetIndex > 0 
			ifTrue:
				[ skeleton
					instVarAt: targetIndex
					put: eachOid ]
			ifFalse:
				[ eachOid = MaOidCalculator oidForNil
					ifFalse: 	[ aMaObjectSerializer recordTruncatedObject: skeleton ] ] ].
	^ skeleton! !

!MaFixedObjectBuffer methodsFor: 'building' stamp: 'cmm 3/27/2006 17:01'!
establishReferencesFrom: anObject using: aMaObjectSerializer
	1
		to: anObject maInstSize
		do:
			[ : instVarIndex | | oid |
			oid _ anObject instVarAt: instVarIndex.
			oid ifNotNil: "could be nil if different class def"
				[ anObject
					instVarAt: instVarIndex
					put: (aMaObjectSerializer objectWithOid: oid) ] ]! !

!MaFixedObjectBuffer methodsFor: 'building' stamp: 'cmm 11/29/2004 16:56'!
populateBodyFor: storageObject using: aMaObjectSerializer
	1
		to: storageObject maInstSize
		do:
			[ :index |
			self
				maInstVarAt: index
				put:
					((storageObject maIsTransient: index)
						ifTrue: [ MaOidCalculator oidForNil ]
						ifFalse: [ aMaObjectSerializer oidFor: (storageObject instVarAt: index) ]) ]! !

!MaFixedObjectBuffer methodsFor: 'building' stamp: 'cmm 10/21/2004 23:18'!
populateHeaderFor: anObject storageObject: storageObject using: aMaObjectSerializer

	| classVersion |
	super
		populateHeaderFor: anObject
		storageObject: storageObject
		using: aMaObjectSerializer.
	classVersion _ 
		aMaObjectSerializer classIdManager
			currentVersionOfClass: (aMaObjectSerializer classFor: anObject).
	self classVersion: classVersion! !

!MaFixedObjectBuffer methodsFor: 'printing' stamp: 'cmm 12/1/2004 23:43'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(classVersion oids)
		on: aStream! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 8/26/2008 02:24'!
bpMapsAt: anIndex
	"Answer the requested Dictionary of attribute positions."
	^ BufferPositionMaps at: anIndex! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 8/26/2008 02:34'!
bpMapsAt: anIndex put: aMaBufferPositionMap 
	^ BufferPositionMaps 
		at: anIndex
		put: aMaBufferPositionMap! !

!MaObjectBuffer class methodsFor: 'private accessing' stamp: 'cmm 4/26/2005 08:00'!
bufferClassFor: aByteArray startPos: anInteger

	^ self bufferClasses at: 
		(self
			bufferTypeIn: aByteArray
			startingAt: anInteger)! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 7/15/2002 23:04'!
bufferClasses

	^BufferClasses! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 4/26/2005 07:57'!
bufferPositionOfControlFields
	"Zero-based position of the control-fields (buffer-type and isStorageObject)."

	^ 9! !

!MaObjectBuffer class methodsFor: 'private accessing' stamp: 'cmm 4/27/2005 23:01'!
bufferPositionOfPhysicalSize
	"Zero-based logical position within this buffer's byteArray that contains the physical size of this buffer."

	^ 6! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 4/26/2005 07:57'!
bufferTypeIn: aByteArray startingAt: startPositionOfObjectBuffer
	"The bufferType is stored in the 4 low-order bits of the controlFields."

	^ (self 
		controlFieldsIn: aByteArray
		startingAt: startPositionOfObjectBuffer) bitAnd: 2r00001111! !

!MaObjectBuffer class methodsFor: 'creation' stamp: 'cmm 7/18/2005 13:22'!
byteArray: aByteArray startPos: anInteger

	^self new
		startPos: anInteger ;
		byteArray: aByteArray ;
		yourself! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 4/27/2005 22:59'!
controlFieldsIn: aByteArray startingAt: startPositionOfObjectBuffer

	^ aByteArray
		maUint: 8
		at: startPositionOfObjectBuffer + self bufferPositionOfControlFields! !

!MaObjectBuffer class methodsFor: 'creation' stamp: 'cmm 7/10/2002 20:28'!
createFromByteArray: aByteArray startPos: anInteger

	^(self
		bufferClassFor: aByteArray
		startPos: anInteger)
			byteArray: aByteArray
			startPos: anInteger
! !

!MaObjectBuffer class methodsFor: 'private accessing' stamp: 'cmm 8/27/2008 14:31'!
defaultBpMap
	^ MaBufferPositionMap! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 8/27/2008 21:39'!
indexOfBpMap: bpMapClass 
	"Answer the 0-based index"
	^ (BufferPositionMaps indexOf: bpMapClass) - 1! !

!MaObjectBuffer class methodsFor: 'initializing' stamp: 'cmm 8/25/2008 21:50'!
initialize
	"Called from preamble of MaObjectSerialization."
	self
		initializeBufferClasses ;
		initializeBufferPositionMaps! !

!MaObjectBuffer class methodsFor: 'initializing' stamp: 'cmm 8/26/2008 02:37'!
initializeBufferClasses
	BufferClasses := Array 
		with: MaByteObjectBuffer
		with: MaVariableObjectBuffer
		with: MaFixedObjectBuffer
		with: MaVariableWordBuffer
		with: MaStorageObjectBuffer! !

!MaObjectBuffer class methodsFor: 'initializing' stamp: 'cmm 8/25/2008 22:38'!
initializeBufferPositionMaps
	BufferPositionMaps := Array new: 16.
	self 
		bpMapsAt: 1
		put: self defaultBpMap! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 4/21/2005 15:43'!
oidSize

	^ 48! !

!MaObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 8/12/2007 19:38'!
unreasonablePhysicalSize
	"An arbitrary limit at this time, we need *something* to check to prevent unreasonable allocation attempts."
	^ 10000000! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 8/25/2008 22:43'!
bpMap
	"Answer the actual MaBufferPositionMap used to map this buffer."
	^ self class bpMapsAt: self bpMapIndex+1! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 8/25/2008 22:17'!
bpMapIndex
	"Answer the index into my BufferPositionMaps array that has my buffer position map.  It is the 4 high-order bits of my controlFields."
	^ self controlFields bitShift: -4! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 8/25/2008 22:24'!
bpMapIndex: anInteger 
	"Set my bpMapIndex to a value between 0 and 15."
	| shifted |
	shifted := anInteger bitShift: 4.
	self controlFields: (shifted bitOr: self type)! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/27/2005 23:14'!
bufferPositionOfClassId
	"Zero-based position of the class id."

	^ 10! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/26/2005 07:57'!
bufferPositionOfControlFields
	"Zero-based position of the control-fields (buffer-type and isStorageObject)."

	^ self class bufferPositionOfControlFields! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/19/2004 15:52'!
bufferPositionOfInstVarAt: anInteger
	"Answer the physical 0-based byte-position within the receivers byteArray
	where the instVar with index anInteger is located."

	^ self headerSize + ((anInteger - 1) * self slotSize)! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
bufferPositionOfOid
	"Zero-based position within a buffer that the oid is at."

	^0
! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
bufferPositionOfPhysicalSize
	"Zero-based logical position within the byteArray that contains the
	physical size of this portion of the buffer (e.g., not including continuations)."

	^self class bufferPositionOfPhysicalSize
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/26/2005 07:35'!
bufferType

	self subclassResponsibility! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
byteArray

	^byteArray! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
byteArray: aByteArray

	byteArray _ aByteArray
! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 10/21/2004 12:41'!
classId

	^self 
		uint: 16
		at: self bufferPositionOfClassId
! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 10/21/2004 12:41'!
classId: anInteger

	self
		uint: 16
		at: self bufferPositionOfClassId
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 10/30/2004 16:00'!
classVersion

	^ 1! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/26/2005 08:03'!
controlFields

	^ self class
		controlFieldsIn: byteArray
		startingAt: startPos! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/26/2005 08:08'!
controlFields: anInteger

	self
		uint: 8
		at: self class bufferPositionOfControlFields
		put: anInteger! !

!MaObjectBuffer methodsFor: 'copying' stamp: 'cmm 10/10/2004 00:03'!
copyWithSameBuffer

	^ self copy! !

!MaObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 12:44'!
createObjectUsing: aMaObjectSerializer
	self subclassResponsibility! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/21/2004 23:29'!
ensureClassUsing: aMaObjectSerializer

	^ (aMaObjectSerializer classIdManager
		classForId: self classId
		ifAbsent:
			[ "going to materialize an instance of the missing class."
			| sourceDefinition |
			sourceDefinition _
				(aMaObjectSerializer classIdManager classDefinitionsForId: self classId) last.  "the most-recent one is the best guess."
			sourceDefinition createClassUsing: aMaObjectSerializer ])! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 6/10/2009 11:35'!
ensureSpaceFor: storageObject using: bpMapClass 
	| totalSize requiredSpace |
	requiredSpace := self 
		physicalSizeFor: storageObject
		using: bpMapClass.
	(totalSize := requiredSpace + self startPos) > MaSerializedGraphBuffer sizeWarningThreshold ifTrue: 
		[ MaObjectSerializationWarning signal: 'Serialization sizeWarningThreshold reached.  Proceed to double it.'.
		MaSerializedGraphBuffer doubleSizeWarningThreshold ].
	totalSize > byteArray size ifTrue: [ self growTo: totalSize * 2 ].
	self physicalSize: requiredSpace! !

!MaObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/22/2004 14:40'!
establishReferencesFrom: anObject using: aMaObjectSerializer
	"This is the second-stage of materializing anObject.  The first stage populated its instVars with oids, this stage now replaces those oids with the actual objects.  Typically, only Fixed and VariableObject buffers will need to do anything on this."! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:09'!
growTo: anInteger

	self byteArray: (
		(ByteArray new: anInteger)
			replaceFrom: 1
			to: byteArray size
			with: byteArray
			startingAt: 1)
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 8/25/2008 22:34'!
headerSize
	"The number of bytes in each object record before its 'data' begins; the objects it references."
	^self bpMap headerSize! !

!MaObjectBuffer methodsFor: 'copying' stamp: 'cmm 3/24/2005 12:00'!
independentCopy

	^ self copy postIndependentCopy! !

!MaObjectBuffer methodsFor: 'initializing' stamp: ''!
initialize

	super initialize.
	startPos _ 0
! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 12/2/2004 12:35'!
instVarsDoWithIndex: twoArgBlock

	1
		to: self objectInstSize
		do:
			[ :index |
			twoArgBlock
				value: (self maInstVarAt: index)
				value: index ]
! !

!MaObjectBuffer methodsFor: 'testing' stamp: 'cmm 10/21/2004 22:46'!
isBytes

	^ false! !

!MaObjectBuffer methodsFor: 'testing' stamp: 'cmm 2/8/2005 18:00'!
isPointers

	^ true! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 4/21/2005 15:44'!
maInstVarAt: anInteger 

	^ self 
		uint: 48   "self class oidSize"
		at: (self bufferPositionOfInstVarAt: anInteger)! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 4/21/2005 15:45'!
maInstVarAt: anInteger put: oid

	self
		uint: 48  "self class oidSize"
		at: (self bufferPositionOfInstVarAt: anInteger)
		put: oid
! !

!MaObjectBuffer methodsFor: 'printing' stamp: 'cmm 3/9/2009 22:35'!
maPrintAbbreviatedOn: aStream 
	self 
		maPrintAttributes: #(
				#oid
				#classId
				#objectInstSize
				#commitNumber
			)
		on: aStream! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 12/2/2004 12:35'!
objectInstSize
	"Answer the capacity of this buffer to hold references to other objects."

	^ self objectSize / self slotSize! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 12/2/2004 12:34'!
objectSize

	^ self physicalSize - self headerSize! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 4/27/2005 23:03'!
oid

	^self 
		uint: 48  "self class oidSize"
		at: self bufferPositionOfOid! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 4/21/2005 15:47'!
oid: anInteger

	self
		uint: 48  "self class oidSize"
		at: self bufferPositionOfOid
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'printing' stamp: 'cmm 4/21/2005 15:46'!
oids
	"This method is intended for printing only.  Use instVarsDoWithIndex: if you need to enumerate my oids."

	| oids |
	self objectInstSize isInteger ifFalse: [ ^ '** invalid **' ].
	oids _ OrderedCollection new.
	1
		to: self objectInstSize
		do: [ :index | oids add: (self maInstVarAt: index) ].
	^ oids! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 12/1/2004 22:54'!
physicalDataSizeNeededFor: storageObject

	^ storageObject maSizeIn: self! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 12/17/2008 00:20'!
physicalSize
	^ self 
		uint: 24
		at: self bufferPositionOfPhysicalSize! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 3/24/2005 14:10'!
physicalSize: anInteger

	self
		uint: 24
		at: self bufferPositionOfPhysicalSize
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 8/27/2008 14:40'!
physicalSizeFor: storageObject 
	^ self 
		physicalSizeFor: storageObject
		using: nil! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 8/27/2008 14:45'!
physicalSizeFor: storageObject using: bpMapClassOrNil 
	| headerSize |
	headerSize := bpMapClassOrNil 
		ifNil: [ self headerSize ]
		ifNotNil: [ bpMapClassOrNil headerSize ].
	^ headerSize + (self physicalDataSizeNeededFor: storageObject)! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 11/21/2004 18:53'!
populateBodyFor: storageObject using: aMaObjectSerializer
	self subclassResponsibility! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 8/27/2008 10:11'!
populateHeaderFor: anObject storageObject: storageObject using: aMaObjectSerializer 
	"physicalSize was already set in ensureSpaceFor:, no need to calculate it again."
	self
		oid: (aMaObjectSerializer oidFor: anObject) ;
		type: self bufferType ;
		bpMapIndex: aMaObjectSerializer bpMapIndex ;
		classId: (aMaObjectSerializer classIdManager 
				idForClass: anObject maSerializationClass
				ifAbsent: 
					[ (aMaObjectSerializer classIdManager addNewClass: anObject maSerializationClass) id ])! !

!MaObjectBuffer methodsFor: 'copying' stamp: 'cmm 7/12/2007 21:23'!
postIndependentCopy
	self trimByteArray! !

!MaObjectBuffer methodsFor: 'testing' stamp: 'cmm 4/19/2009 17:45'!
references: oid 
	^ self isPointers and: 
		[ (1 to: self objectInstSize) anySatisfy: [ : n | (self maInstVarAt: n) = oid ] ]! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 4/28/2005 12:50'!
slotSize
	^ 6   "self class oidSize / 8"! !

!MaObjectBuffer methodsFor: 'access' stamp: ''!
startPos

	^startPos! !

!MaObjectBuffer methodsFor: 'private' stamp: ''!
startPos: anInteger

	startPos _ anInteger
! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 3/26/2007 22:36'!
trimByteArray
	byteArray _ self trimmedByteArray.
	startPos _ 0! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 3/26/2007 22:21'!
trimmedByteArray
	^ byteArray copyFrom: startPos+1 to: startPos + self physicalSize! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 3/29/2007 16:06'!
type
	"Answer the type of buffer this is.
		1=MaByteObjectBuffer
		2=MaVariableObjectBuffer
		3=MaFixedObjectBuffer
		4=MaVariableWordBuffer 
		5=MaStorageObjectBuffer"
	^ self controlFields bitAnd: 2r00001111! !

!MaObjectBuffer methodsFor: 'access' stamp: 'cmm 8/25/2008 22:06'!
type: anInteger 
	| controlFieldsValue withZeroedBits |
	controlFieldsValue := self controlFields.
	"Zero out 4 lowest-order bits, that's where this field is stored."
	withZeroedBits := controlFieldsValue >> 4 << 4.
	"Now OR these bits with anInteger."
	self controlFields: (withZeroedBits bitOr: anInteger)! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:09'!
uint: numberOfBits at: position

	^byteArray
		maUint: numberOfBits
		at: self startPos + position
! !

!MaObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:10'!
uint: numberOfBits at: zeroBasedIndexPosition put: valueInteger

	^byteArray
		maUint: numberOfBits
		at: self startPos + zeroBasedIndexPosition
		put: valueInteger
! !

MaObjectBuffer subclass: #MaVariableBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaVariableBuffer commentStamp: 'cmm 12/1/2004 23:13' prior: 0!
This class encapsulates an object that has a variable logical size, primarily Smalltalk collections including Byte-oriented collections such as ByteArray and String.

I add no additional fields, only behavior.!

MaVariableBuffer subclass: #MaByteObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaByteObjectBuffer commentStamp: '<historical>' prior: 0!
I encapsulate objects that represented as a series of bytes; such as Strings, ByteArrays, CompiledMethods, etc.

!

!MaByteObjectBuffer methodsFor: 'converting' stamp: 'cmm 12/1/2004 22:47'!
asByteArray

	^ self asByteObject: ByteArray! !

!MaByteObjectBuffer methodsFor: 'converting' stamp: 'cmm 2/23/2005 14:38'!
asByteObject: byteClass

	^ self fillByteObject: (byteClass new: self objectSize)! !

!MaByteObjectBuffer methodsFor: 'converting' stamp: 'cmm 12/1/2004 22:47'!
asString

	^ self asByteObject: String! !

!MaByteObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:32'!
bufferType
	^ 1! !

!MaByteObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 22:41'!
createObjectUsing: aMaObjectSerializer
	"Objects with byte-based storage-objects can and do materialize now, rather than pointer-based storage-objects, which aren't actually well-formed until after establishingReferencesFrom:."
	^ (self ensureClassUsing: aMaObjectSerializer)
		maMaterializeFrom: self
		using: aMaObjectSerializer! !

!MaByteObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:10'!
fillByteObject: byteObject

	^byteObject
		replaceFrom: 1
		to: byteObject size
		with: byteArray
		startingAt: self startPos + self headerSize + 1.
! !

!MaByteObjectBuffer methodsFor: 'testing' stamp: 'cmm 10/8/2004 12:09'!
isBytes

	^ true! !

!MaByteObjectBuffer methodsFor: 'testing' stamp: 'cmm 2/8/2005 18:01'!
isPointers

	^ false! !

!MaByteObjectBuffer methodsFor: 'accessing' stamp: 'cmm 7/18/2005 13:32'!
numberToStoreFor: anObject using: aMaObjectSerializer
	"This method stores either anObject itself or the oid for anInteger."
	self shouldNotImplement! !

!MaByteObjectBuffer methodsFor: 'actions' stamp: 'cmm 11/21/2004 19:04'!
populateBodyFor: storageObject using: aMaObjectSerializer

	self
		replaceFrom: 1
		to: storageObject size
		with: storageObject
		startingAt: 1! !

!MaByteObjectBuffer methodsFor: 'private' stamp: 'cmm 4/3/2003 00:10'!
replaceFrom: startInteger to: endInteger with: byteObject startingAt: startingInteger

	byteArray
		replaceFrom: self startPos + self headerSize + startInteger
		to: self startPos + self headerSize + endInteger
		with: byteObject
		startingAt: startingInteger
! !

!MaByteObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 11:08'!
slotSize

	^ 1! !

MaByteObjectBuffer subclass: #MaStorageObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaStorageObjectBuffer commentStamp: 'cmm 5/1/2005 21:12' prior: 0!
I am a buffer for an object that requires first-class, custom 'storage-object' for serialization.  I contain a MaSerializedGraphBuffer which can be used to materialize the first-class storage object.!

!MaStorageObjectBuffer methodsFor: 'accessing' stamp: 'cmm 5/1/2005 21:13'!
bufferType
	^ 5! !

!MaStorageObjectBuffer methodsFor: 'accessing' stamp: 'cmm 5/2/2005 13:39'!
buffersDo: aBlock

	(MaSerializedGraphBuffer byteArray: self asByteArray) buffersDo: aBlock! !

!MaStorageObjectBuffer methodsFor: 'accessing' stamp: 'cmm 5/1/2005 22:29'!
createObjectUsing: aMaObjectSerializer

	^ (self ensureClassUsing: aMaObjectSerializer)
		maMaterializeFromGraph: self asByteArray
		using: aMaObjectSerializer copyWithNewOidSpace! !

!MaVariableBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 12:41'!
numberToStoreFor: anObject using: aMaObjectSerializer
	"This method stores either anObject itself or the oid for anInteger."
	self subclassResponsibility! !

MaVariableBuffer subclass: #MaVariableObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaVariableObjectBuffer commentStamp: 'cmm 7/29/2007 17:35' prior: 0!
This class encapsulates variably-sized objects that reference objects.

My buffer fields are (these are 0-based indexes, sorry):

	(see superclass)
	14 = inst var #1!

!MaVariableObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:33'!
bufferType
	^ 2! !

!MaVariableObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 12:44'!
createObjectUsing: aMaObjectSerializer
	| class |
	class _ self ensureClassUsing: aMaObjectSerializer.
	"Set and Dictionary are special-case for this because we store their logical rather than physical representation.  Therefore, dispatch to the class to build the skeleton for VariableObjectBuffers."
	^ class maLoadVariableObjectFrom: self! !

!MaVariableObjectBuffer methodsFor: 'creation' stamp: 'cmm 11/23/2004 10:28'!
establishReferencesFrom: anObject using: aMaObjectSerializer
	"Set and Dictionary require special-case processing, therefore we dispatch."
	anObject maEstablishPointerReferencesUsing: aMaObjectSerializer! !

!MaVariableObjectBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 12:41'!
numberToStoreFor: anObject using: aMaObjectSerializer
	^ aMaObjectSerializer oidFor: anObject! !

!MaVariableObjectBuffer methodsFor: 'building' stamp: 'cmm 11/28/2004 16:21'!
populateBodyFor: storageObject using: aMaObjectSerializer
	"Logical storage of collections varies by collection, therefore dispatch back to it."
	storageObject
		maStreamVariablyInto: self
		for: aMaObjectSerializer! !

!MaVariableObjectBuffer methodsFor: 'printing' stamp: 'cmm 12/1/2004 23:43'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(oids)
		on: aStream
! !

MaVariableBuffer subclass: #MaVariableWordBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaVariableWordBuffer commentStamp: 'cmm 8/26/2008 00:33' prior: 0!
I encapsulate objects that represented as a series of words (2-byte numbers).  These types are useful for multimedia like sounds.!

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 5/1/2005 21:08'!
bufferType
	^ 4! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 12/2/2004 12:35'!
createObjectUsing: aMaObjectSerializer
	| answer |
	answer _ (self ensureClassUsing: aMaObjectSerializer) basicNew: self objectInstSize.
	1 to: self objectInstSize do:
		[ : x |
		answer
			basicAt: x
			put: (self wordAt: x) ].
	^ answer! !

!MaVariableWordBuffer methodsFor: 'testing' stamp: 'cmm 2/8/2005 18:01'!
isPointers

	^ false! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:12'!
maInstVarAt: logicalPosition

	^ self wordAt: logicalPosition! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:12'!
maInstVarAt: logicalPosition put: anInteger

	^ self
		wordAt: logicalPosition
		put: anInteger! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 12:41'!
numberToStoreFor: anInteger using: aMaObjectSerializer

	^ anInteger! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/21/2004 19:19'!
populateBodyFor: storageObject using: aMaObjectSerializer

	1
		to: storageObject maInstSize
		do:
			[ :index |
			self
				wordAt: index
				put: (storageObject instVarAt: index) ]! !

!MaVariableWordBuffer methodsFor: 'printing' stamp: 'cmm 11/19/2004 17:28'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(words)
		on: aStream! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/20/2004 11:08'!
slotSize

	^ 4! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:10'!
wordAt: logicalPosition

	^ self 
		uint: 32
		at: (self bufferPositionOfInstVarAt: logicalPosition)! !

!MaVariableWordBuffer methodsFor: 'accessing' stamp: 'cmm 11/19/2004 15:09'!
wordAt: logicalPosition put: anInteger

	self
		uint: 32
		at: (self bufferPositionOfInstVarAt: logicalPosition)
		put: anInteger! !

!MaVariableWordBuffer methodsFor: 'printing' stamp: 'cmm 12/2/2004 12:35'!
words
	"This is intended for printing only."
	self objectInstSize isInteger ifFalse: [ ^ '** invalid **' ].
	^ (1 to: self objectInstSize) collect: [ : index | self maInstVarAt: index ]! !

MaObject subclass: #MaObjectSerializer
	instanceVariableNames: 'oidManager classIdManager preMadeObjectBuffers graphBuffer createProxyBlock traversalStrategy amBusy truncatedObjects preferences bpMapIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-API'!

!MaObjectSerializer class methodsFor: 'debugging' stamp: 'cmm 4/19/2009 20:52'!
fileIn: aDirectoryEntryFile 
	^ aDirectoryEntryFile containingDirectory 
		maFileNamed: aDirectoryEntryFile name
		do: 
			[ : stream | 
			stream binary.
			self objectFromStream: stream ]! !

!MaObjectSerializer class methodsFor: 'creation' stamp: 'cmm 10/15/2002 22:15'!
new

	^self new: 1000
! !

!MaObjectSerializer class methodsFor: 'creation' stamp: ''!
new: anInteger

	^super new optimumByteArraySize: anInteger
! !

!MaObjectSerializer class methodsFor: 'debugging' stamp: 'cmm 3/17/2009 17:56'!
objectFromStream: stream 
	| serializer buffers |
	stream binary.
	buffers := OrderedCollection new.
	stream maBuffersDo: [ : each | buffers add: each ].
	serializer := MaObjectSerializer new.
	buffers size > 1 ifTrue: 
		[ serializer := MaObjectSerializer new classDefinitionsByteArray: buffers first ].
	^ serializer materializeGraph: buffers second! !

!MaObjectSerializer class methodsFor: 'creation' stamp: 'cmm 10/25/2005 22:00'!
protocol: aCollection

	^ self new
		protocol: aCollection ;
		yourself! !

!MaObjectSerializer class methodsFor: 'debugging' stamp: 'cmm 8/23/2005 18:56'!
testMaterialize: anObject

	| s1 graphBuffer |
	s1 := self new.
	graphBuffer := s1 serializeGraph: anObject.
	^ self new
		classDefinitionsByteArray: s1 classDefinitionsByteArray ;
		materializeGraph: graphBuffer byteArray copy! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/1/2005 19:49'!
append: anObject
	"Append only anObject to the receiver.  However, in the case where anObject is stored via a storage-object (see #maAsStorageObject), the entire graph of the storage object must be stored."

	| storageObject |
	storageObject _ anObject maAsStorageObject.
	anObject maWantsPreSerialization ifTrue: [ self preSerialize: storageObject ].
	storageObject ~~ anObject
		ifTrue:
			[ "This is a storage object, so serialize it into an inner serialized graph ByteArray."
			storageObject _ (self copyWithNewBuffer serializeGraph: storageObject) trimmedByteArray ].
	self graphBuffer increaseBufferSizeBy:
		(self
			bufferFor: anObject
			storageObject: storageObject
			startingAt: self graphBuffer bufferSize)
				physicalSize.
	"Since the need is so scarce anyway, if you order pre-serialization, you get post too."
	anObject maWantsPreSerialization ifTrue: [ self postSerialize: storageObject ]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 1/11/2007 21:04'!
appendGraph: anObject do: oneArgBlock
	"Answer a MaSerializedObjectBuffer containing anObject and all objects
	it can reach, serialized into aByteArray."

	self beBusy.
	anObject
		maGraphDo:
			[ : path : parent : index |
			(path last
				maShouldAppendWithPath: path
				parent: parent
				index: index)
				ifTrue:
					[ self append: path last.
					oneArgBlock value: path last ] ]
		using: self traversalStrategy.
	self beBored.
	^ self graphBuffer trimByteArray! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/29/2002 23:22'!
beBored

	amBusy _ false
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/29/2002 23:33'!
beBusy

	amBusy _ true
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 8/27/2008 14:47'!
bpMap
	^ MaObjectBuffer bpMapsAt: bpMapIndex + 1! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 8/27/2008 10:14'!
bpMapIndex
	"The index into the MaObjectBuffer's 'BufferPositionMaps' Array referring to the MaBufferPositionMap, which identifies the attribute offsets."
	^ bpMapIndex! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 8/27/2008 20:47'!
bpMapIndex: anInteger 
	"Set the 0-based index of the MaBufferPositionMap to be used by this serializer."
	bpMapIndex := anInteger! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 8/27/2008 14:46'!
bufferFor: anObject storageObject: storageObject startingAt: anInteger 
	| buffer |
	buffer := anObject == storageObject 
		ifTrue: [ storageObject maSelectPreMadeObjectBufferFrom: self ]
		ifFalse: [ self preMadeStorageObjectBuffer ].
	buffer
		startPos: anInteger ;
		ensureSpaceFor: storageObject
			using: self bpMap.
	buffer byteArray == self byteArray ifFalse: 
		[ "aByteArray must not have been big enough.."
		self byteArray: buffer byteArray ].
	buffer 
		populateHeaderFor: anObject
		storageObject: storageObject
		using: self.
	buffer 
		populateBodyFor: storageObject
		using: self.
	^ buffer! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
byteArray

	^self graphBuffer byteArray
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
byteArray: aByteArray

	self graphBuffer byteArray: aByteArray.
	preMadeObjectBuffers do: [ :each | each byteArray: aByteArray ]
! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 6/3/2004 14:07'!
classDefinitions: aDictionary
	"aDictionary keys are the classId (an Integer), values are a collection of known MaClassDefinitions, representing different versions of that class."

	self classIdManager classDefinitionsById: aDictionary! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 6/8/2004 21:14'!
classDefinitionsByteArray
	"Answer a ByteArray that can be used to reinitialize a new instance of the receiver so that it can materialize the objects it has serialized."

	^ (
self copyWithNewBuffer serializeGraph: self classIdManager classDefinitionsById) trimmedByteArray! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 6/8/2004 22:09'!
classDefinitionsByteArray: aByteArray
	"Initialize the receiver with aByteArray that materializes to my classDefinitions.  These are the classDefinitions used to work with objects that were being used when the user saved off the byteArray by calling the getter, #classDefinitionsByteArray."

	self classDefinitions: (self materializeGraph: aByteArray)! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 5/23/2004 22:18'!
classDefinitionsOid

	^self oidFor: self classIdManager classDefinitionsById! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 4/10/2005 18:56'!
classFor: anObject 

	^ anObject maSerializationClass! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
classIdManager

	^classIdManager
! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 5/2/2005 15:03'!
classIdManager: aMaClassIdManager

	classIdManager _ aMaClassIdManager.
	self setUpClassDefinitionProcessing! !

!MaObjectSerializer methodsFor: 'copying' stamp: 'cmm 3/24/2005 11:59'!
copyWithNewBuffer

	^ self copy
		postCopyWithNewBuffer ;
		yourself! !

!MaObjectSerializer methodsFor: 'copying' stamp: 'cmm 3/24/2005 11:58'!
copyWithNewOidSpace
	"Answer a new instance of the me that shares my class-ids, but not the oids."
	
	^ self copyWithNewBuffer
		postCopyWithNewOidSpace ;
		yourself! !

!MaObjectSerializer methodsFor: 'serializing' stamp: 'cmm 4/20/2009 10:14'!
fileOut: anObject toFileNamed: fileName in: aFileDirectory 
	"Write anObject to a file named fileName in aFileDirectory."
	^ aFileDirectory 
		maFileNamed: fileName
		do: 
			[ : stream | 
			stream
				binary ;
				position: 0.
			self 
				object: anObject
				toStream: stream ]! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 1/20/2003 22:26'!
finalizeOids

	oidManager finalizeOids! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
graphBuffer

	^graphBuffer
! !

!MaObjectSerializer methodsFor: 'building' stamp: ''!
graphBuffer: aMaSerializedGraphBuffer

	graphBuffer _ aMaSerializedGraphBuffer
! !

!MaObjectSerializer methodsFor: 'event handling' stamp: 'cmm 12/12/2004 18:54'!
handleClassModification: aModifiedClassDefinitionEvent

	aModifiedClassDefinitionEvent isModified ifFalse: [ ^ self ].
	aModifiedClassDefinitionEvent item isMeta ifTrue: [ ^ self ].
	oidManager
		handleClassModification: aModifiedClassDefinitionEvent item
		using: self.
	classIdManager
		handleClassModification: aModifiedClassDefinitionEvent item
		using: self! !

!MaObjectSerializer methodsFor: 'testing' stamp: 'cmm 7/17/2002 22:49'!
hasOidFor: anObject

	^oidManager hasOidFor: anObject! !

!MaObjectSerializer methodsFor: 'copying' stamp: 'cmm 3/24/2005 11:51'!
independentCopy
	"Answer a completely independent copy of the receiver.  This will probably mostly be used during debugging."

	^ self copy postIndependentCopy! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 8/27/2008 10:15'!
initialize
	super initialize.
	bpMapIndex := 0. "0-based index"
	preferences := MaObjectSerializerPreferences new.
	self
		oidManager: MaOidManager new ;
		classIdManager: MaClassIdManager new ;
		initializeTraversalStrategy ;
		toCreateProxies: 
			[ : oid | 
			MaObjectSerializationUserError signal: 'No createProxyBlock specified.  See MaObjectSerializer>>toCreateProxies:' ].
	self graphBuffer: (MaSerializedGraphBuffer new: 50).
	self initializePreMadeObjectBuffers.
	self beBored.
	truncatedObjects := WeakIdentityKeyDictionary new.	"want a WeakIdentitySet.."
	self setUpPreAndPostProcessing! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 10/21/2004 12:53'!
initializePreMadeObjectBuffers

	preMadeObjectBuffers _ MaObjectBuffer bufferClasses collect:
		[ :each |
		each
			byteArray: self byteArray
			startPos: 0 ]
! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 11/29/2004 11:04'!
initializeTraversalStrategy
	traversalStrategy _
		MaObjectGraphTraversalStrategy new
			traverseWhen:
				[ : path : parent : indexInteger | 
				path last
					maShouldTraverseWithPath: path
					parent: parent
					index: indexInteger ]! !

!MaObjectSerializer methodsFor: 'testing' stamp: 'cmm 6/5/2004 17:26'!
isTruncated: anObject
	"A truncated object is one that has been read, but the in-image definition did not have a place for one of its inst vars.  This is useful for then detecting if the user tries to write that object back out to warn him that he will lose data."

	^ truncatedObjects includesKey: anObject! !

!MaObjectSerializer methodsFor: 'materializing' stamp: 'cmm 10/9/2004 23:58'!
materializeGraph: aByteArray

	^self
		materializeGraph: aByteArray
		do: [ : eachObject : eachBuffer | "do nothing" ]
! !

!MaObjectSerializer methodsFor: 'materializing' stamp: 'cmm 1/30/2005 20:47'!
materializeGraph: aByteArray do: twoArgBlock
	"Answer a fully-formed object from aByteArray of aMaSerializedGraphBuffer.  If buffers are missing to complete the full-graph, I will substitute with proxy's based on the block specified by toCreateProxies:."

	"Guard against stepping on my own buffers if I'm busy serializing or materializing already."
	^ amBusy
		ifTrue:
			[ self copyWithNewBuffer
				byteArray: aByteArray;
				materializeGraphDo: twoArgBlock ]
		ifFalse:
			[ self
				byteArray: aByteArray;
				materializeGraphDo: twoArgBlock ]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 7/18/2008 11:23'!
materializeGraphDo: twoArgBlock 
	"Materialize as much as the object in the receivers byteArray as possible.  For each object *materialized*, value twoArgBlock [ : eachObject : eachBuffer | ].  twoArgBlock is not valued for objects encountered in the materialized graph if they were already present in the receivers oidManager, that way we know when objects are exactly materialized."
	| skeletons rootObject hashedCollections |
	skeletons := OrderedCollection new: 48.
	rootObject := nil.
	self beBusy.
	self graphBuffer buffersDo: 
		[ : each | 
		| object |
		object := self 
			objectWithOid: each oid
			ifFound: 
				[ : foundObj | 
				foundObj maIsMutatingProxy ifTrue: 
					[ skeletons add: (Association 
							key: 
								(self 
									newSkeletonFor: each
									fromProxy: foundObj)
							value: each copyWithSameBuffer) ].
				foundObj ]
			ifAbsent: 
				[ | newObject |
				skeletons add: (Association 
						key: (newObject := self 
								newSkeletonFor: each
								fromProxy: nil)
						value: each copyWithSameBuffer).
				newObject ].
		rootObject ifNil: [ rootObject := object ] ].
	hashedCollections := OrderedCollection new.
	skeletons do: 
		[ : eachAssociation | 
		| eachObject eachBuffer |
		eachObject := eachAssociation key.
		eachBuffer := eachAssociation value.
		(eachObject maIsHashedCollection and: [ eachObject notEmpty ]) 
			ifTrue: [ hashedCollections add: eachAssociation ]
			ifFalse: 
				[ eachBuffer 
					establishReferencesFrom: eachObject
					using: self ] ].
	hashedCollections do: 
		[ : eachAssociation | 
		| eachObject eachBuffer |
		eachObject := eachAssociation key.
		eachBuffer := eachAssociation value.
		eachBuffer 
			establishReferencesFrom: eachObject
			using: self ].
	hashedCollections do: [ : eachAssociation | eachAssociation key rehash ].
	skeletons do: 
		[ : eachAssociation | 
		| eachFullyFormedObject eachBuffer |
		eachFullyFormedObject := eachAssociation key.
		eachBuffer := eachAssociation value.
		eachFullyFormedObject maWantsPostMaterialization ifTrue: [ self postMaterialize: eachFullyFormedObject ].
		twoArgBlock 
			value: eachFullyFormedObject
			value: eachBuffer ].
	self beBored.
	^ rootObject! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 1/18/2005 16:09'!
newSkeletonFor: aMaObjectBuffer fromProxy: aMaMutatingProxy

	| skel |
	skel _ aMaObjectBuffer createObjectUsing: self.
	aMaMutatingProxy ifNotNil: [ aMaMutatingProxy becomeForward: skel copyHash: false ].
	self
		oidOf: skel
		is: aMaObjectBuffer oid.
	^ skel! !

!MaObjectSerializer methodsFor: 'serializing' stamp: 'cmm 4/19/2009 18:25'!
object: anObject toStream: aWriteStream 
	| objectGb |
	objectGb := self serializeGraph: anObject.
	self protocolEstablished 
ifFalse: 
		[ objectGb buffersMissingFromWhole ifNotEmptyDo: [: missing | MaSoftwareError signal: 'Incomplete graph, check serializer configuration.' ].
		"serialize protocol"
		aWriteStream nextPutAll: self classDefinitionsByteArray ].
	aWriteStream nextPutAll: objectGb byteArray.
	^ objectGb! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 3/27/2006 16:45'!
objectWithOid: anInteger
	^ oidManager
		objectWithOid: anInteger
		ifAbsent: [ self proxyFor: anInteger ]! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 3/20/2003 21:55'!
objectWithOid: anInteger ifAbsent: aBlock

	^oidManager
		objectWithOid: anInteger
		ifAbsent: aBlock
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 3/20/2003 21:54'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^oidManager
		objectWithOid: anInteger
		ifFound: oneArgBlock
		ifAbsent: aBlock
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 10/30/2006 00:09'!
objectsDo: oneArgBlock 
	self oidsAndObjectsDo: [ : eachOid : eachObject | oneArgBlock value: eachObject ]! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 4/20/2003 22:18'!
oidCount
	"Answers the number of objects that have oids."

	^oidManager oidCount! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 3/20/2003 21:54'!
oidFor: anObject

	^oidManager oidFor: anObject
! !

!MaObjectSerializer methodsFor: 'building' stamp: ''!
oidManager: aMaOidManager

	oidManager _ aMaOidManager
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 6/23/2004 17:41'!
oidOf: anObject is: anInteger

	oidManager
		oidOf: anObject
		is: anInteger! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 10/30/2006 00:09'!
oidsAndObjectsDo: twoArgBlock
	oidManager oidsAndObjectsDo: twoArgBlock! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 12/29/2002 16:49'!
optimumByteArraySize: anInteger

	self byteArray: (ByteArray new: anInteger).
	self resetByteArray! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 3/24/2005 14:20'!
postCopyWithNewBuffer

	graphBuffer _ MaSerializedGraphBuffer new: 1000.
	self
		initializePreMadeObjectBuffers;
		resetByteArray;
		beBored! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/7/2008 16:28'!
postCopyWithNewOidSpace
	self oidManager: 
		(oidManager species new
			useStatisticsFrom: oidManager ;
			yourself)! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 3/24/2005 11:49'!
postIndependentCopy
	"Answer a completely independent copy of the receiver.  This will probably mostly be used during debugging."

	self 
		oidManager: oidManager independentCopy;
		classIdManager: self classIdManager independentCopy;
		resetByteArray.
	graphBuffer _ graphBuffer copy.
	traversalStrategy _ traversalStrategy copy! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 4/10/2005 18:00'!
postMaterialize: anObject 
	"maPostMaterialize could be useful for when you don't necessarily require serialization, but needed so that it *can* be used, if desired."

	(anObject respondsTo: #maPostMaterialize) 
		ifTrue: [anObject maPostMaterialize].
	anObject maOriginalClass withAllSuperclassesDo: 
			[:eachClass | 
			preferences postMaterializers 
				maAt: eachClass name
				ifPresent: 
					[:valuators | 
					valuators do: [:each | each valueWithArguments: { 
										anObject}]]
				ifAbsent: 
					["do nothing"

					]]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 4/10/2005 18:00'!
postSerialize: anObject 
	"maPostSerialize could be useful for when you don't necessarily require serialization, but needed so that it *can* be used, if desired."

	(anObject respondsTo: #maPostSerialize) ifTrue: [anObject maPostSerialize].
	anObject maOriginalClass withAllSuperclassesDo: 
			[:eachClass | 
			preferences postSerializers 
				maAt: eachClass name
				ifPresent: [:valuators | valuators do: [:each | each value: anObject]]
				ifAbsent: 
					["do nothing"

					]]! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:42'!
preMadeByteObjectBuffer

	^ self preMadeObjectBufferAt: 1! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:43'!
preMadeFixedObjectBuffer

	^ self preMadeObjectBufferAt: 3! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:42'!
preMadeObjectBufferAt: bufferTypeInteger

	^ preMadeObjectBuffers at: bufferTypeInteger! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/1/2005 21:42'!
preMadeStorageObjectBuffer

	^ self preMadeObjectBufferAt: 5! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 11/11/2004 15:43'!
preMadeVariableObjectBuffer

	^ self preMadeObjectBufferAt: 2! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/1/2005 22:14'!
preMadeVariableWordBuffer

	^ self preMadeObjectBufferAt: 4! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 4/19/2009 19:55'!
preSerialize: anObject 
	"maPreserialize could be useful for when you don't necessarily require serialization, but needed so that it *can* be used, if desired."
	(anObject respondsTo: #maPreSerialize) ifTrue: [ anObject maPreSerialize ].
	anObject class withAllSuperclassesDo: 
		[ : eachClass | 
		preferences preSerializers 
			maAt: eachClass name
			ifPresent: 
				[ : valuators | 
				valuators do: [ : each | each valueWithArguments: {  anObject  } ] ]
			ifAbsent: 
				[ "do nothing"
				 ] ]! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 11/26/2004 09:46'!
preferences
	^ preferences! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 3/16/2009 20:38'!
protocol
	"The protocol established (directly or indirectly) for this serializer."
	^ classIdManager protocol! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 1/26/2009 13:57'!
protocol: aCollection 
	"This is only called once per instance, don't try to reset the protocol because this implementation doesn't remove any old protocol.  Create a new serializer if you have to."
	| sc |
	sc := aCollection asSortedCollection: [ : a : b | a name < b name ].
	sc do: [ : each | classIdManager addNewClass: each ].
	self classIdManager beImmutable! !

!MaObjectSerializer methodsFor: 'testing' stamp: 'cmm 3/16/2009 20:24'!
protocolEstablished
	^ classIdManager isMutable not! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 4/23/2003 23:16'!
proxyFor: oid

	^oidManager retainIdentityOfProxy: (createProxyBlock value: oid)
! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 6/5/2004 17:27'!
recordTruncatedObject: anObject
	"A truncated object is one that has been read, but the in-image definition did not have a place for one of its inst vars.  This is useful for then detecting if the user tries to write that object back out to warn him that he will lose data.  See also isTruncated:."

	truncatedObjects at: anObject put: nil! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 12/29/2004 17:30'!
rehashOids

	oidManager rehashOids! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 11/26/2004 09:43'!
resetByteArray
	"Ensure my preMade buffers share the same byteArray as my graphBuffer (a performance optimization) and set my size to 0 objects."
	preMadeObjectBuffers first byteArray ~~ self byteArray
		ifTrue: [ preMadeObjectBuffers do: [ :each | each byteArray: self byteArray ] ].
	self graphBuffer resetBufferSize! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 6/8/2006 15:45'!
resetOidManager
	"If receiving a byteArray from another serializer, this method should be invoked prior to materializing here so cached oids in the oidManager that may not match the objects that were serialized by the other serializer."
	oidManager reset
! !

!MaObjectSerializer methodsFor: 'serializing' stamp: 'cmm 3/16/2009 20:12'!
serializeGraph: anObject
	"Serialize anObject and answer it as a MaSerializedGraphBuffer."
	^self
		serializeGraph: anObject
		do: [ :each | nil ]
! !

!MaObjectSerializer methodsFor: 'serializing' stamp: 'cmm 3/16/2009 20:12'!
serializeGraph: anObject do: oneArgBlock
	"Serialize anObject and answer it as a MaSerializedGraphBuffer.  For each object traversed in the serialization, value oneArgBlock."
	^ self copyWithNewBuffer
		resetByteArray;
		appendGraph: anObject
		do: oneArgBlock! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 11/2/2005 22:48'!
setUpClassDefinitionProcessing

	preferences
		beforeSerializingAny: #MaClassReference
		do:
			[ : aMaClassReference |
			aMaClassReference id:
				(classIdManager
					idForClass: aMaClassReference classObject
					ifAbsent:
						[ (classIdManager addNewClass: aMaClassReference classObject theNonMetaClass) id ]).
			aMaClassReference := nil ] ;

		afterMaterializingAny: #MaClassDefinition
		do:
			(MessageSend
				receiver: classIdManager
				selector: #addClassDefinition:)! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 4/19/2009 19:04'!
setUpPreAndPostProcessing
	"Initiailize the pre and post-materializers for classes that come with standard Squeak.  Base Squeak uses one of two methods for serializing objects; ReferenceStream and ImageSegments.  MaObjectSerialization more-closely resembles ReferenceStream.  While the setup for these processors is based on the behavior in those other two frameworks, there are bound to be some minor differences."

	self setUpClassDefinitionProcessing.

	preferences
		beforeSerializingAny: #Color
		do:
			[ : aColor | 
			aColor flushCache "saves space".
			thisContext home removeSelf ].

"preferences
	beforeSerializingAny: #Form
	do: [ : aForm | aForm hibernate ].
preferences
	afterSerializingAny: #Form
	do: [ : aForm | aForm unhibernate ].
preferences
	afterMaterializingAny: #Form
	do: [ : aForm | aForm unhibernate ]."
"preferences
	beforeSerializingAny: #ColorForm
	do: [ : aColorForm | aColorForm clearColormapCache ]."
	preferences
		beforeSerializingAny: #Morph
		do:
			[ : aPasteUpMorph | 
			aPasteUpMorph prepareToBeSaved.  "Amen" 
			thisContext home removeSelf ].
"preferences
	afterSerializingAny: #ScriptEditorMorph
	do: [ : aScriptEditorMorph | aScriptEditorMorph class = BooleanScriptEditor ifFalse: [ aScriptEditorMorph unhibernate ] ].
preferences
	afterMaterializingAny: #ScriptEditorMorph
	do: [ : aScriptEditorMorph | aScriptEditorMorph class = BooleanScriptEditor ifFalse: [ aScriptEditorMorph unhibernate ] ]."
	preferences
		beforeSerializingAny: #TTCFont
		do: 
			[ : aTTCFont | 
			aTTCFont flushCache.
			thisContext home removeSelf ].

"preferences
		beforeSerializingAny: #Wonderland
		do: [ : aWonderland | aWonderland prepareToBeSaved ].
preferences
	beforeSerializingAny: #ViewerFlapTab
	do: [ : aViewFlapTab | aViewFlapTab hibernate ]."
self maMarked: 'dev'.
"You've got this commented out because it changes the shape of the object while you're serializing it, which ends up causing the graphBuffer to not be #isWhole (which causes problems on materialization).
Do we need this?  It appears that Project>>exportSegmentWithChangeSet:  fileName:  directory: calls it at the end.  Also, Project>>exportSegmentWithCatagories: classes: fileName: directory:"
"preferences
	afterSerializingAny: #ViewerFlapTab
	do: [ : aViewerFlapTab | aViewerFlapTab unhibernate ].
preferences
	afterMaterializingAny: #ViewerFlapTab
	do: [ : aViewerFlapTab | aViewerFlapTab unhibernate ]."
	preferences
		beforeSerializingAny: #Project
		do:
			[ : aProject |  | world |
			world := aProject world.
			aProject world setProperty: #optimumExtentFromAuthor toValue: aProject world extent.  "As suggested by Project>>#storeOnServerAssumingNameValid".
			"The following is from Project>>#exportSegmentWithChangeSet:fileName:directory:"
			Utilities emptyScrapsBook.
			world currentHand pasteBuffer: nil.	  "don't write the paste buffer."
			world currentHand mouseOverHandler initialize.	  "forget about any references here"
				"Display checkCurrentHandForObjectToPaste."
			Command initialize.
			world clearCommandHistory.
			world fullReleaseCachedState; releaseViewers. 
			world cleanseStepList.
			world releaseSqueakPages.
			ScriptEditorMorph writingUniversalTiles: (aProject projectParameterAt: #universalTiles ifAbsent: [false]).
			thisContext home removeSelf ].
	preferences
		afterMaterializingAny: #Project
		do:
			[ : aProject |
			aProject setParent: Project current.
			aProject world beWorldForProject: aProject. "sets aProject's worldState"
			"This behavior suggested by ImageSegment>>#comeFullyUpOnReload:"
			aProject ensureChangeSetNameUnique.
			Project addingProject: aProject.
			aProject restoreReferences.
			self maMarked: 'dev'.  "need to restore dependents??"
			ScriptEditorMorph writingUniversalTiles: 
				((aProject projectPreferenceAt: #universalTiles) ifNil: [false]).
			thisContext home removeSelf ].
"preferences
	afterMaterializingAny: #WorldState
	do:
		[ : aWorldState |
		aWorldState
			convertStepList ;
			convertAlarms ]."! !

!MaObjectSerializer methodsFor: 'building' stamp: ''!
toCreateProxies: oneArgBlock

	createProxyBlock _ oneArgBlock
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: ''!
traversalStrategy

	^traversalStrategy
! !

MaObject subclass: #MaObjectSerializerPreferences
	instanceVariableNames: 'preSerializers postSerializers postMaterializers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-API'!

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/11/2005 11:17'!
afterMaterializingAny: className do: oneArgValuator
	"Set up preference for materializing instances of the class named className by sending oneArgValuator.  The first argument is the object being serialized, the second is the serializer (aMaObjectSerializer) doing the serialization."

	| valuators |
	self
		validate: className
		has: #maWantsPostMaterialization.
	valuators _ 
		(postMaterializers
			at: className
			ifAbsentPut: [ OrderedCollection new ]).
	(valuators includes: oneArgValuator) ifFalse: [ valuators add: oneArgValuator ]! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/11/2005 11:17'!
afterSerializingAny: className do: oneArgValuator
	"Set up preference for serializing instances of class named className by sending oneArgValuator.  The first argument is the object being serialized, the second is the serializer (aMaObjectSerializer) doing the serialization."

	| valuators |
	self
		validate: className
		has: #maWantsPreSerialization.
	valuators _ postSerializers
		at: className
		ifAbsentPut: [ OrderedCollection new ].
	(valuators includes: oneArgValuator) ifFalse: [ valuators add: oneArgValuator ]! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/11/2005 11:17'!
beforeSerializingAny: className do: oneArgValuator
	"Set up preference for serializing instances of aClass by sending oneArgValuator.  The first argument is the object being serialized, the second is the serializer (aMaObjectSerializer) doing the serialization.
	Note, only do this if aClass is present."

	| valuators |
	self
		validate: className
		has: #maWantsPreSerialization.
	valuators _ 
		preSerializers
			at: className
			ifAbsentPut: [ OrderedCollection new ].
	(valuators includes: oneArgValuator) ifFalse: [ valuators add: oneArgValuator ]! !

!MaObjectSerializerPreferences methodsFor: 'initializing' stamp: 'cmm 11/28/2004 19:22'!
initialize
	super initialize.
	preSerializers _ Dictionary new.
	postSerializers _ Dictionary new.
	postMaterializers _ Dictionary new! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/26/2004 10:17'!
postMaterializers
	^ postMaterializers! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/28/2004 17:12'!
postSerializers
	^ postSerializers! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 11/26/2004 10:17'!
preSerializers
	^ preSerializers! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/3/2005 22:54'!
releasePostMaterializationFor: className
	"Remove all post-materialization behaviors for the class named className."
	postMaterializers
		removeKey: className
		ifAbsent: [ "ok" ]! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/3/2005 22:55'!
releasePostSerializationFor: className
	"Remove all post-materialization behaviors for the class named className."
	postSerializers
		removeKey: className
		ifAbsent: [ "ok" ]! !

!MaObjectSerializerPreferences methodsFor: 'pre and post processing' stamp: 'cmm 2/3/2005 22:51'!
releasePreserializationFor: className
	"Remove all preserialization behaviors for the Class named className."
	preSerializers
		removeKey: className
		ifAbsent: [ "ok" ]! !

!MaObjectSerializerPreferences methodsFor: 'validate' stamp: 'cmm 3/9/2009 20:23'!
validate: className has: selector

	(Smalltalk hasClassNamed: className) ifFalse: [ "No validation needed" ^ self ].
	((Smalltalk at: className) canUnderstand: selector)
		ifFalse:
			[ MaObjectSerializationUserError signal: 'Need to implement ', selector, ' on ', className ]! !

MaObject subclass: #MaOidCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaOidCalculator commentStamp: 'cmm 6/1/2005 09:46' prior: 0!
The oid ranges are as follows:

The range from (0 to: SmallInteger maxVal - SmallInteger minVal) are reserved for:  user objects, the non-integral atomics including 65536 characters and space for 4000000 new-object oids (bigger than any transaction should ever be!!).  We should allow a few thousand for future-use as well.

SmallInteger minVal actually starts at the oid with the value SmallInteger maxVal + 1.  Thus, SmallInteger maxVal has the oid

We start at the bottom so user-objects are contiguous above 
 
  a   n u m b e r   l i n e
|<--- SmallInteger range -------------->|< - - - - - -  LargeInteger range - - - - - - - - - ->|
atomics | chars | new objects          |    user objects             | Floats | SmallIntegers  |

0
	nil
1
	false
2
	true
3
	indicate an unused slot in a MaHashIndex
4 to: 65539
	DB character-set (only SB currently supported)
65540 to: 66540
	future use?
66541 to: 66541 + 4000000  "no more than four-million new objects are allowed in a single commit."
	new-object oids
4066542 to: 281468533259712 (oid for smallest float - 1)
	user objects
281468533259713 to: self oidForSmallestOptimizedInteger-1
	32-bit IEEE floats
281472829227008 to: 281474976710655
	SmallIntegers
!

!MaOidCalculator class methodsFor: 'special' stamp: 'cmm 4/29/2005 12:20'!
firstCharacterOid

	^ 4! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 8/8/2002 23:01'!
floatFromOid: anInteger

	^Float fromIEEE32Bit: anInteger - self oidForSmallestFloat! !

!MaOidCalculator class methodsFor: 'special' stamp: 'cmm 4/21/2005 15:40'!
highestPossibleOid

	^ 281474976710655    "(2 raisedTo: 48) - 1"! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/6/2002 23:52'!
integerFromOid: oidInteger

	^oidInteger - self oidForZero! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 4/21/2005 15:32'!
isOidForFloat: oidInteger

	^ oidInteger
		between: self oidForSmallestFloat
		and: 281472828227007  "self oidForSmallestOptimizedInteger - 1"! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 6/1/2005 09:43'!
isOidForOptimizedInteger: oidInteger

	^ oidInteger
		between: 281472829227008  "self oidForZero + SmallInteger minVal"
		and: 281474976710655  "self oidForZero + SmallInteger maxVal"! !

!MaOidCalculator class methodsFor: 'special' stamp: 'cmm 4/29/2005 12:21'!
lastCharacterOid

	"^self firstCharacterOid + 65535"   "DBCS"
	^ 65539! !

!MaOidCalculator class methodsFor: 'atomics' stamp: 'cmm 9/1/2002 22:54'!
newOidMinimum

	^66541! !

!MaOidCalculator class methodsFor: 'atomics' stamp: 'cmm 8/8/2002 22:57'!
objectWithOid: anInteger ifNone: aBlock

	anInteger == self oidForNil ifTrue: [ ^nil ].
	anInteger == self oidForFalse ifTrue: [ ^false ].
	anInteger == self oidForTrue ifTrue: [ ^true ].
	(self isOidForFloat: anInteger)
		ifTrue:
			[ ^self floatFromOid: anInteger ].
	(self isOidForOptimizedInteger: anInteger)
		ifTrue:
			[ ^self integerFromOid: anInteger ].
	(anInteger
		between: self firstCharacterOid
		and: self lastCharacterOid)
			ifTrue:
				[ ^Character value: anInteger - self firstCharacterOid ].
	^aBlock value! !

!MaOidCalculator class methodsFor: 'atomics' stamp: 'cmm 8/6/2002 23:40'!
oidForCharacter: aCharacter

	^self firstCharacterOid + aCharacter asciiValue! !

!MaOidCalculator class methodsFor: 'atomics' stamp: 'cmm 8/6/2002 23:41'!
oidForFalse

	^1! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 8/8/2002 23:06'!
oidForFloat: aFloat

	^aFloat asIEEE32BitWord + self oidForSmallestFloat! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 8/6/2002 23:51'!
oidForInteger: anInteger

	^anInteger + self oidForZero! !

!MaOidCalculator class methodsFor: 'atomics' stamp: 'cmm 8/6/2002 23:37'!
oidForNil

	^0! !

!MaOidCalculator class methodsFor: 'floats' stamp: 'cmm 4/21/2005 15:32'!
oidForSmallestFloat

	^ 281468533259713  "self oidForSmallestOptimizedInteger - 16rFFFFFFFF"! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 4/21/2005 15:32'!
oidForSmallestOptimizedInteger

	^ self oidForInteger: SmallInteger minVal! !

!MaOidCalculator class methodsFor: 'atomics' stamp: 'cmm 8/6/2002 23:41'!
oidForTrue

	^2! !

!MaOidCalculator class methodsFor: 'integers' stamp: 'cmm 6/1/2005 09:42'!
oidForZero

	"^16rFFFFFFFFFFFF - SmallInteger maxVal"
	^ 281473902968832! !

MaObject subclass: #MaOidManager
	instanceVariableNames: 'objects oids nextOid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaOidManager methodsFor: 'actions' stamp: 'cmm 12/22/2008 16:19'!
finalizeOids
	objects := objects reject: [ : each | each isNil ].
	oids finalizeValues! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 7/26/2005 13:09'!
getNextOid

	^ nextOid _ nextOid + 1! !

!MaOidManager methodsFor: 'event handling' stamp: 'cmm 6/24/2004 11:59'!
handleClassModification: aClass using: aMaObjectSerializer
	"optional subclass responsibility"! !

!MaOidManager methodsFor: 'testing' stamp: 'cmm 7/17/2002 22:51'!
hasOidFor: anObject

	^oids includesKey: anObject! !

!MaOidManager methodsFor: 'copying' stamp: 'cmm 3/24/2005 11:36'!
independentCopy

	^ self copy postIndependentCopy! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 12/22/2008 15:47'!
initialize
	super initialize.
	self
		reset ;
		resetNextOid! !

!MaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 4/9/2009 14:32'!
objectCountByClass
	^ (objects collect: [ : e | e class ]) asBag sortedCounts! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 12/27/2002 16:03'!
objectWithOid: anInteger ifAbsent: aBlock

	^self
		objectWithOid: anInteger
		ifFound: [ :foundObj | foundObj ]
		ifAbsent: aBlock! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 12/25/2002 12:15'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^MaOidCalculator
		objectWithOid: anInteger
		ifNone:
			[ objects
				maAt: anInteger
				ifPresent:
					[ :obj |
					obj   "oid key marked to be cleaned"
						ifNil: [ aBlock value ]
						ifNotNil: [ oneArgBlock value: obj ] ]
				ifAbsent: [ aBlock value ] ]! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 4/20/2003 22:18'!
oidCount

	^oids size! !

!MaOidManager methodsFor: 'accessing' stamp: ''!
oidFor: anObject

	^self
		oidFor: anObject
		ifAbsent:
			[ self
				oidOf: anObject
				is: self getNextOid ]
! !

!MaOidManager methodsFor: 'accessing' stamp: 'cmm 11/8/2006 21:54'!
oidFor: anObject ifAbsent: aBlock 
	^ anObject maRequiresOwnBuffer 
		ifTrue: 
			[ oids 
				maAt: anObject
				ifPresent: 
					[ : oid | 
					oid 
						ifNil: [ aBlock value ]
						ifNotNil: [ oid ] ]
				ifAbsent: aBlock ]
		ifFalse: [ anObject maOid ]! !

!MaOidManager methodsFor: 'building' stamp: 'cmm 12/22/2008 15:58'!
oidOf: anObject is: anInteger 
	objects 
		at: anInteger
		put: anObject.
	^ oids 
		at: anObject
		put: anInteger! !

!MaOidManager methodsFor: 'actions' stamp: 'cmm 10/30/2006 00:06'!
oidsAndObjectsDo: twoArgBlock
	objects keysAndValuesDo: twoArgBlock! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 3/24/2005 11:36'!
postIndependentCopy

	objects _ objects copy.
	oids _ oids copy.
	self resetNextOid! !

!MaOidManager methodsFor: 'actions' stamp: 'cmm 12/29/2004 17:29'!
rehashOids

	oids rehash! !

!MaOidManager methodsFor: 'actions' stamp: 'cmm 12/22/2008 15:47'!
reset
	oids := MaWeakIdentityKeyDictionary new.
	objects := MaWeakValueDictionary new! !

!MaOidManager methodsFor: 'private' stamp: ''!
resetNextOid

	nextOid _ MaOidCalculator newOidMinimum
! !

!MaOidManager methodsFor: 'building' stamp: 'cmm 7/14/2008 16:30'!
retainIdentityOfProxy: aMaMutatingProxy 
	^ objects 
		at: aMaMutatingProxy maOid
		put: aMaMutatingProxy! !

!MaOidManager methodsFor: 'private' stamp: 'cmm 5/7/2008 16:28'!
useStatisticsFrom: anotherOidManager
	"Do nothing for now, since only MagmaOidManagers have an interest in statistics."! !

MaObject subclass: #MaSerializedGraphBuffer
	instanceVariableNames: 'byteArray'
	classVariableNames: 'SizeWarningThreshold'
	poolDictionaries: ''
	category: 'Ma object serialization-support'!

!MaSerializedGraphBuffer commentStamp: 'cmm 6/10/2009 09:32' prior: 0!
I represent a serialized graph of objects.  Normally entire graphs are serialized but a #toCreateProxies: block may be specified for materialization so that the graph will be terminated with proxy objects.!

!MaSerializedGraphBuffer class methodsFor: 'creation' stamp: 'cmm 5/1/2005 22:27'!
byteArray: aByteArray

	^ self new
		byteArray: aByteArray ;
		yourself! !

!MaSerializedGraphBuffer class methodsFor: 'accessing' stamp: 'cmm 6/10/2009 11:35'!
doubleSizeWarningThreshold
	self sizeWarningThreshold: self sizeWarningThreshold * 2! !

!MaSerializedGraphBuffer class methodsFor: 'accessing' stamp: 'cmm 9/22/2002 23:52'!
headerSize
	"header only has 32-bit integer representing the physicalSize of my byteArray that holds the entire serialized graph."

	^4! !

!MaSerializedGraphBuffer class methodsFor: 'accessing' stamp: 'cmm 6/10/2009 09:34'!
initialize
	super initialize.
	self sizeWarningThreshold: 10000000! !

!MaSerializedGraphBuffer class methodsFor: 'creation' stamp: ''!
new: anInteger

	^self new resetByteArray: (ByteArray new: anInteger)
! !

!MaSerializedGraphBuffer class methodsFor: 'accessing' stamp: 'cmm 6/10/2009 09:33'!
sizeWarningThreshold
	^ SizeWarningThreshold! !

!MaSerializedGraphBuffer class methodsFor: 'accessing' stamp: 'cmm 6/10/2009 09:34'!
sizeWarningThreshold: anInteger 
	SizeWarningThreshold := anInteger! !

!MaSerializedGraphBuffer methodsFor: 'private' stamp: 'cmm 10/21/2004 12:52'!
bufferPositionsDo: oneArgBlock

	"Value oneArgBlock with the value of the starting position of each
	buffer in the receiver."

	| pos end |

	pos _ self headerSize.
	end _ self bufferSize - 1.
	[ pos <= end ] whileTrue:
		[ oneArgBlock value: pos.
		pos _
			pos +
				(byteArray 
					maUint: 24
					at: pos + MaObjectBuffer bufferPositionOfPhysicalSize) ]
! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 4/3/2003 00:10'!
bufferSize

	^byteArray 
		maUint: 32
		at: 0
! !

!MaSerializedGraphBuffer methodsFor: 'private building' stamp: 'cmm 4/3/2003 00:11'!
bufferSize: anInteger

	byteArray
		maUint: 32
		at: 0
		put: anInteger
! !

!MaSerializedGraphBuffer methodsFor: 'private' stamp: 'cmm 4/26/2005 07:59'!
bufferTypeAt: startPositionOfObjectBuffer

	^ MaObjectBuffer
		bufferTypeIn: byteArray
		startingAt: startPositionOfObjectBuffer! !

!MaSerializedGraphBuffer methodsFor: 'debugging' stamp: 'cmm 6/15/2005 22:53'!
buffers

	| coll |

	coll _ OrderedCollection new.
	self buffersDo: [ :each | coll add: each independentCopy ].
	^coll
! !

!MaSerializedGraphBuffer methodsFor: 'actions' stamp: 'cmm 4/3/2003 00:11'!
buffersDo: oneArgBlock
	"Value oneArgBlock with each ObjectBuffer in the
	receiver.  There is one ObjectBuffer for each object in the graph that
	the receiver represents."

	| preMadeBuffers |
	preMadeBuffers _ self newPremadeBuffers.
	self bufferPositionsDo:
		[ :eachPosition | | buffer |
		buffer _ (preMadeBuffers at: (self bufferTypeAt: eachPosition)).
		buffer
			byteArray: byteArray;
			startPos: eachPosition.
		oneArgBlock value: buffer ]! !

!MaSerializedGraphBuffer methodsFor: 'debugging' stamp: 'cmm 4/19/2009 19:01'!
buffersMissingFromWhole
	"Answer whether I have all the object buffers needed to reconstitute my entire graph."
	| oids missing |
	missing := OrderedCollection new.
	oids := (self buffers collect: [ : each | each oid ]) asSet.
	self buffersDo: 
		[ : each | 
		each isPointers ifTrue: 
			[ each oids do: 
				[ : eachOid | 
				((MaOidCalculator isOidForOptimizedObject: eachOid) not and: [ (oids includes: eachOid) not ]) ifTrue: [ missing add: eachOid -> each copyWithSameBuffer ] ] ] ].
	^ missing! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: ''!
byteArray
	"One ByteArray holds the entire graph of objects."

	^byteArray
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: ''!
byteArray: aByteArray

	byteArray _ aByteArray
! !

!MaSerializedGraphBuffer methodsFor: 'private' stamp: 'cmm 7/16/2002 21:42'!
headerSize

	^self class headerSize
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: 'cmm 3/7/2005 14:37'!
increaseBufferSizeBy: anInteger

	anInteger < self headerSize
		ifTrue:
			[ MaObjectSerializationSoftwareError signal: 'This object being appended is not properly supported.' ].
	self bufferSize: self bufferSize + anInteger
! !

!MaSerializedGraphBuffer methodsFor: 'debugging' stamp: 'cmm 2/7/2005 17:29'!
isWhole
	"Answer whether I have all the object buffers needed to reconstitute my entire graph."

	^ self buffersMissingFromWhole isEmpty! !

!MaSerializedGraphBuffer methodsFor: 'private creation' stamp: 'cmm 10/21/2004 12:52'!
newPremadeBuffers

	^MaObjectBuffer bufferClasses collect: [ :each | each new ]
! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 2/15/2005 22:18'!
objectCount

	| count |
	count _ 0.
	self buffersDo: [ : each | count _ count + 1 ].
	^ count! !

!MaSerializedGraphBuffer methodsFor: 'private creation' stamp: 'cmm 7/12/2007 21:24'!
postCopy
	super postCopy.
	self trimByteArray ! !

!MaSerializedGraphBuffer methodsFor: 'printing' stamp: 'cmm 7/25/2006 23:48'!
printOn: aStream
	super printOn: aStream.
	byteArray notNil
		ifTrue:
			[ aStream
				nextPutAll: ' (';
				maPrint: self objectCount;
				nextPutAll: ' objects in ';
				maPrint: self bufferSize;
				nextPutAll: ' bytes)' ]
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: ''!
resetBufferSize
	"Reset the current pointer (which is the bufferSize) back to the beginning."

	self bufferSize: self headerSize
! !

!MaSerializedGraphBuffer methodsFor: 'building' stamp: ''!
resetByteArray: aByteArray

	self
		byteArray: aByteArray;
		resetBufferSize
! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 5/3/2005 12:41'!
rootBuffer

	self buffersDo: [ : each | ^ each ]! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 3/15/2009 21:17'!
sameBuffers
	"Answer an Array of my individual MaObjectBuffers whose byteArray all share mine."
	| arg x |
	arg := Array new: self objectCount.
	x := 0.
	self buffersDo: 
		[ : each | 
		arg 
			at: (x := x + 1)
			put: each copyWithSameBuffer ].
	^ arg! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 1/11/2007 21:34'!
trimByteArray
	byteArray _ self trimmedByteArray! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 4/3/2003 00:11'!
trimmedByteArray

	^byteArray
		copyFrom: 1
		to: self bufferSize! !

!TTFontDescription class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:16'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"Materialize the DiskProxy which computes a reference to an appropriate object in this materializing system."

	| diskProxy |
	diskProxy _ aMaObjectSerializer materializeGraph: aByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!TTFontDescription methodsFor: '*ma object serialization' stamp: 'cmm 2/6/2008 16:42'!
maAsStorageObject 
	^ DiskProxy 
		global: #TTFontDescription selector: #descriptionNamed:
		args: { self name }! !

!TTFontDescription methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:15'!
maUsesStandardStorage 
	^ false! !

!Float class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!Float methodsFor: '*ma object serialization' stamp: 'cmm 8/8/2002 23:05'!
maOid

	^MaOidCalculator oidForFloat: self! !

!Color methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 13:12'!
maWantsPreSerialization 
	^ true! !

!Behavior methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 15:27'!
maAllInstVarNamesAt: anInteger

	| x |
	x _ 0.
	self maAllInstVarNamesDo:
		[ : each | 
		x _ x + 1.
		x = anInteger ifTrue: [ ^ each ] ].
	self error: 'Index out of bounds:  ', anInteger printString! !

!Behavior methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 15:24'!
maAsStorageObject

	^ MaClassReference className: self theNonMetaClass name! !

!Behavior methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 15:18'!
maUsesStandardStorage

	^ false! !

!Behavior methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 15:18'!
maWantsPreSerialization
	^ true! !

MaSoftwareError subclass: #MaObjectSerializationSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

MaWarning subclass: #MaObjectSerializationWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

!EToyVocabulary class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:15'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	| vocabOrDiskProxy |
	vocabOrDiskProxy _ aMaObjectSerializer materializeGraph: aByteArray.
	^ vocabOrDiskProxy maIsDiskProxy
		ifTrue: [ vocabOrDiskProxy comeFullyUpOnReload: nil ]
		ifFalse: [ vocabOrDiskProxy ]! !

!EToyVocabulary methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 21:49'!
maAsStorageObject
	"copied from #objectForDataStream:"

	vocabularyName == #eToy ifFalse: [^ self].

	^ DiskProxy 
		global: #Vocabulary
		selector: #vocabularyNamed: 
		args: (Array with: vocabularyName)
! !

!EToyVocabulary methodsFor: '*ma object serialization' stamp: 'cmm 2/8/2005 16:36'!
maUsesStandardStorage
	^ vocabularyName == #eToy! !

!DisplayScreen class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:14'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"This method exists to mirror the logic in my instance-side #objectForDataStream, whereby a DiskProxy is stored instead.  For Ma object serialization, this was done on my instance-side in #maAsStorageObject."

	| diskProxy |
	diskProxy _ aMaObjectSerializer materializeGraph: aByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!DisplayScreen methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 12:42'!
maAsStorageObject
	"Emulate the same behavior as #objectForDataStream:."

	^ DiskProxy global: #Display selector: #yourself args: #()! !

!DisplayScreen methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 12:42'!
maUsesStandardStorage 
	^ false! !

!Integer methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForInteger: self
! !

!Set class methodsFor: '*ma object serialization' stamp: 'cmm 11/22/2004 16:08'!
maIsLogicallyVariable
	"Answer whether, for ma serialization purposes, I am stored as a fixed or variable object."
	^ true! !

!Set class methodsFor: '*ma object serialization' stamp: 'cmm 12/2/2004 12:35'!
maLoadVariableObjectFrom: aMaVariableObjectBuffer

	| skeleton |
	skeleton _ self new: aMaVariableObjectBuffer objectInstSize.
	1
		to: aMaVariableObjectBuffer objectInstSize
		do: [ :index | skeleton add: (aMaVariableObjectBuffer maInstVarAt: index) ].
	^ skeleton! !

!Set methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:55'!
maBufferInstSize

	^ self size! !

!Set methodsFor: '*ma object serialization' stamp: 'cmm 3/27/2006 17:05'!
maEstablishPointerReferencesUsing: aMaObjectSerializer
	"I am currently loaded with oids of the objects that I should be referencing.  Now that objects for these oids are, themselves, materialized, I can now replace my referernces to oids wtih references to the real objects."
	| fullOfOidsCopy |
	self isEmpty ifTrue: [ ^ self ]. "performance, avoid the copy if possible.."
	fullOfOidsCopy _ self copy.
	self maRemoveAll.
	fullOfOidsCopy do:
		[ :each |
		self add: (aMaObjectSerializer objectWithOid: each) ]! !

!Set methodsFor: '*ma object serialization' stamp: ''!
maIsHashedCollection

	^true
! !

!Set methodsFor: '*ma object serialization' stamp: 'cmm 11/28/2004 16:21'!
maStreamVariablyInto: aMaVariableBuffer for: aMaObjectSerializer
	"Put the receivers instance variables into aMaVariableObjectBuffer as they fit."

	| index |
	index _ 1.
	self do:
		[ : eachLinkedObject |
		aMaVariableBuffer
			maInstVarAt: index
			put:
				(aMaVariableBuffer 
					numberToStoreFor: eachLinkedObject
					using: aMaObjectSerializer).
		index _ index + 1 ].
	3 "skip array and tally, they're taken care of logically, above."
		to: self maInstSize
		do:
			[ : namedIndex |
			aMaVariableBuffer
				maInstVarAt: index + namedIndex
				put: (aMaObjectSerializer oidFor: (self instVarAt: namedIndex)) ]! !

!Association class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:13'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"This method exists to mirror the logic in Association>>#objectForDataStream, whereby if the Array being stored is a Smalltalk global, a DiskProxy is stored instead.  For Ma object serialization, this was done on my instance-side in #maAsStorageObject.  If I was not stored as the DiskProxy, then I would not get to this method."

	| diskProxy |
	diskProxy _ aMaObjectSerializer materializeGraph: aByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!Association methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:13'!
maAsStorageObject
	"I am about to be serialized into a ByteArray.  If I am a known global, write a proxy that will hook up with the same resource in the destination system.  This behavior emulates what Association>>#objectForDataStream: does."

	^ self maUsesStandardStorage 
		ifTrue: [ self ]
		ifFalse:
			[ DiskProxy
				global: #Smalltalk selector: #associationOrUndeclaredAt: 
				args: (Array with: key) ]! !

!Association methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:10'!
maUsesStandardStorage

	^ (Smalltalk associationAt: key ifAbsent: [nil]) ~~ self! !

!ScriptEditorMorph methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 14:35'!
maWantsPostMaterialization 
	^ true! !

!Pragma methodsFor: '*ma object serialization' stamp: 'cmm 9/17/2006 12:46'!
maCopyAndDisconnect
	^ self copy
		setMethod: nil ;
		yourself! !

MaUserError subclass: #MaObjectSerializationUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

!ViewerFlapTab methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 14:34'!
maWantsPostMaterialization 
	^ true! !

!StrikeFont methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:10'!
maAsStorageObject 

	^ DiskProxy
		global: #StrikeFont selector: #familyName:size:emphasized:
		args: { self familyName.  self height.  self emphasis }! !

!StrikeFont methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:05'!
maUsesStandardStorage 

	^ false! !

!FlapTab class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:15'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"This method exists to mirror the logic in my instance-side #objectForDataStream, whereby if the FlapTab being stored is a global flap (i.e., present in all Projects), a DiskProxy is stored instead.  For Ma object serialization, this was done on my instance-side in #maAsStorageObject.  If I was not stored as the DiskProxy, then I would not get to this method."

	| diskProxy |
	diskProxy _ aMaObjectSerializer materializeGraph: aByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!FlapTab methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 12:47'!
maAsStorageObject
	"Emulating the behavior of #objectForDataStream:."
	^ self isGlobalFlap
		ifTrue:
			[ DiskProxy
				global: #Flaps selector: #globalFlapTabOrDummy: 
				args: {self flapID} ]
		ifFalse: [ self ]! !

!FlapTab methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 12:47'!
maUsesStandardStorage
	^ self isGlobalFlap not! !

!SystemOrganizer class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:16'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"A simpler, alternative way to store a direct global reference than using DiskProxy."

	^ SystemOrganization! !

!SystemOrganizer methodsFor: '*ma object serialization' stamp: 'cmm 2/17/2005 13:56'!
maAsStorageObject 
	^ String maEmpty! !

!SystemOrganizer methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 17:13'!
maUsesStandardStorage 
	^ false! !

!Morph methodsFor: '*ma object serialization' stamp: 'cmm 2/22/2005 12:49'!
maTransientVariables

	^ owner == World  "If serializing a live Morph in the world."
		ifTrue: [ super maTransientVariables, #('owner') ]
		ifFalse: [ super maTransientVariables ]! !

!Morph methodsFor: '*ma object serialization' stamp: 'cmm 2/7/2005 21:55'!
maWantsPreSerialization
	^ true! !

!HandMorph class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:15'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	^ ActiveHand! !

!HandMorph methodsFor: '*ma object serialization' stamp: 'cmm 6/30/2004 13:58'!
maAsStorageObject
	"We don't yet support serialization of individual HandMorphs.  For now, we restore any HandMorph as a logical link to the ActiveHand."

	^ String maEmpty! !

!HandMorph methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!ProtoObject class methodsFor: '*ma object serialization' stamp: 'cmm 1/17/2005 12:29'!
maIsLogicallyVariable
	"Answer whether, for ma serialization purposes, I am stored as a fixed or variable object."
	^ self isVariable! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 13:39'!
maAsStorageObject
	"Some objects should be converted to another object before being stored
	in a buffer."

	^self
! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 14:26'!
maBufferInstSize
	"Answer the number of pointers to other objects I logically have (which can be fewer than the number of physical pointers due to implementation of extra growth-space)."
	^ self maInstSize! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 14:28'!
maIsHashedCollection

	^false
! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 2/13/2005 21:52'!
maIsTransient: varIndex
	"Answers whether my object referenced at varIndex should be serialized."
	
	varIndex = 0 "root object" ifTrue: [ ^ false ].
	self maTransientVariables isEmpty ifTrue: [ ^ false ].
	varIndex > self class instSize ifTrue: [ ^ false ].
	^ self maTransientVariables includes: (self class maAllInstVarNamesAt: varIndex)! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 14:52'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	| cl |
	cl _ self class.
	cl isBytes ifTrue: [ ^ aMaObjectSerializer preMadeByteObjectBuffer ].
	(cl isWords and: [ cl isPointers not ]) ifTrue: [ ^ aMaObjectSerializer preMadeVariableWordBuffer ].
	cl maIsLogicallyVariable ifTrue: [ ^ aMaObjectSerializer preMadeVariableObjectBuffer ].
	^ aMaObjectSerializer preMadeFixedObjectBuffer! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 17:57'!
maSerializationClass
	"All objects that can be serialized by Ma object serialization have their classes recorded mapped to an id except for Classes instances.  The class for these objects maps directly to Metaclass, rather than their specific metaclass instance."

	^ self class! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 17:58'!
maShouldAppendWithPath: path parent: parent index: indexInteger
	^ parent isNil
	or:
		[ self maRequiresOwnBuffer
		and: [ (parent maIsTransient: indexInteger) not ] ]! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 17:59'!
maShouldTraverseWithPath: path parent: parent index: indexInteger
	| cl |
	cl _ self class.
	cl isBytes ifTrue: [ ^ false ].
	(cl isVariable and: [ cl isPointers not ]) ifTrue: [ ^ false ].
	^ self maUsesStandardStorage
	and: [ (parent maIsTransient: indexInteger) not ]! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 14:27'!
maSizeIn: aMaObjectBuffer
	"Answer the size of the buffer that contains the object references, excluding the header."

	^ self maBufferInstSize * aMaObjectBuffer slotSize! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 18:00'!
maTransientVariables
	^ #()! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 17:30'!
maUsesStandardStorage
	"Override this method to store a different externalized version of me."

	^ true! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 18:04'!
maWantsPostMaterialization
	"Most objects do not need any preserialization behavior, therefore this allows the serializer to avoid the overhead of withAllSuperclassesDo:."
	^ false! !

!ProtoObject methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 18:04'!
maWantsPreSerialization
	"Most objects do not need any preserialization behavior, therefore this allows the serializer to avoid the overhead of withAllSuperclassesDo:."
	^ false! !

!Symbol class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:47'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This is the standard-case for building a skeleton of a variable-byte-sized object."
	^ aMaByteObjectBuffer asString asSymbol! !

!SystemDictionary class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:16'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	^ Smalltalk! !

!SystemDictionary methodsFor: '*ma object serialization' stamp: 'cmm 12/19/2002 23:13'!
maAsStorageObject
	"We don't even need to store the name of the global.  It's class
	gives it away."

	^String maEmpty
! !

!SystemDictionary methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!UndefinedObject class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!UndefinedObject methodsFor: '*ma object serialization' stamp: ''!
maOid
	^MaOidCalculator oidForNil! !

!BasicClassOrganizer class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:13'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"This method exists to mirror the logic in my instance-side #objectForDataStream:, whereby if the organizer being stored has a normal Class subect, a DiskProxy is stored instead.  For Ma object serialization, this was done on my instance-side in #maAsStorageObject.  If I was not stored as the DiskProxy, then I would not get to this method."

	| diskProxy |
	diskProxy _ aMaObjectSerializer materializeGraph: aByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!BasicClassOrganizer methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:19'!
maAsStorageObject 

	^ self maUsesStandardStorage
		ifTrue: [ super maAsStorageObject ]
		ifFalse: [ DiskProxy global: self subject name selector: #organization args: #() ]! !

!BasicClassOrganizer methodsFor: '*ma object serialization' stamp: 'cmm 2/4/2005 00:17'!
maUsesStandardStorage 

	^ (self hasSubject and: [ self subject isKindOf: Class ]) not! !

!AbstractFont class methodsFor: '*ma object serialization' stamp: 'cmm 8/5/2008 12:59'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"Materialize the DiskProxy which computes a reference to an appropriate StrikeFont in this materializing system."

	| diskProxy |
	diskProxy _ aMaObjectSerializer materializeGraph: aByteArray.
	^ diskProxy comeFullyUpOnReload: nil! !

!MethodProperties methodsFor: '*ma object serialization' stamp: 'cmm 9/17/2006 12:53'!
maCopyWithDisconnectedPragmas
	| answer |
	answer _ self copy.
	answer maPragmas: (answer pragmas collect: [ : each | each maCopyAndDisconnect ]).
	^ answer! !

!MethodProperties methodsFor: '*ma object serialization' stamp: 'cmm 9/17/2006 12:52'!
maPragmas: anArray
	pragmas _ anArray! !

!Boolean class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!Character class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!Character methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForCharacter: self
! !

MaStatCollection subclass: #MaSerializationStat
	instanceVariableNames: 'timeToSerializeHistory timeToMaterializeHistory houseCleaningTimeHistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-API'!

!MaSerializationStat methodsFor: 'enumerate' stamp: 'cmm 5/7/2008 15:20'!
historysDo: aBlock 
	{ 
		houseCleaningTimeHistory.
		timeToMaterializeHistory.
		timeToSerializeHistory
	 } do: aBlock! !

!MaSerializationStat methodsFor: 'historys' stamp: 'cmm 5/9/2008 17:04'!
houseCleaningTimeHistory
	"MaObjectSerializers must do house-cleaning to maintain good performance but this, itself, consumes a bit of time, which is tracked by this stat."
	^houseCleaningTimeHistory! !

!MaSerializationStat methodsFor: 'initialize-release' stamp: 'cmm 5/7/2008 17:38'!
initialize
	super initialize.
	houseCleaningTimeHistory := MaStatHistory name: 'House Cleaning Times'.
	timeToMaterializeHistory := MaStatHistory name: 'Time Spent Materializing'.
	timeToSerializeHistory := MaStatHistory name: 'Time Spent Serializing'! !

!MaSerializationStat methodsFor: 'historys' stamp: 'cmm 4/27/2009 20:50'!
serializationStats
	"Statistics related to local serialization and materialization of objects."
	^ { 
		timeToSerializeHistory.
		timeToMaterializeHistory.
		houseCleaningTimeHistory
	 }! !

!MaSerializationStat methodsFor: 'historys' stamp: 'cmm 5/9/2008 17:03'!
timeToMaterializeHistory
	"The time spent materializing objects.  In a client-server application, this means materializing requests on the server or responses on the client."
	^timeToMaterializeHistory! !

!MaSerializationStat methodsFor: 'historys' stamp: 'cmm 5/9/2008 17:03'!
timeToSerializeHistory
	"The time spent serializing objects.  In a client-server application, this means serializing requests on the client or responses on the server."
	^timeToSerializeHistory! !

!MaStatHistory methodsFor: '*ma object serialization' stamp: 'cmm 5/5/2008 23:48'!
maTransientVariables
	^ super maTransientVariables , #('timer' 'guard' )! !

MaNotification subclass: #MaIncomingChangeSetNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-exceptions'!

!MaIncomingChangeSetNotification methodsFor: 'as yet unclassified' stamp: 'cmm 2/3/2005 21:22'!
defaultAction
	"The ChangeSet will be created if it does not exist.  Resume with true to instruct Magma to file in the code with the ChangeSet."

	self resume: false! !

!Class class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 14:21'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	| classReference |
	classReference _ aMaObjectSerializer materializeGraph: aByteArray.
	^ (aMaObjectSerializer classIdManager classDefinitionsForId: classReference id) last
		ensureClassUsing: aMaObjectSerializer! !

!Class methodsFor: '*ma object serialization' stamp: 'cmm 10/27/2004 22:53'!
maSerializationClass

	^ Class! !

!CompiledMethod class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:14'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	^ (aMaObjectSerializer materializeGraph: aByteArray) asCompiledMethod! !

!CompiledMethod methodsFor: '*ma object serialization' stamp: 'cmm 11/12/2004 10:54'!
maAsStorageObject

	^ MaCompiledMethodStorage newFor: self! !

!CompiledMethod methodsFor: '*ma object serialization' stamp: 'cmm 9/17/2006 12:02'!
maFixUpPragmas
	self pragmas do: [ : each | each setMethod: self ]! !

!CompiledMethod methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!Object class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer
	^ true! !

!Object class methodsFor: '*ma object serialization' stamp: 'cmm 2/23/2005 14:54'!
maLoadVariableObjectFrom: aMaVariableObjectBuffer
	"This is the standard-case for building a skeleton of a variably-sized object."
	| skeleton |
	skeleton _ self basicNew: aMaVariableObjectBuffer objectInstSize - self instSize.
	1
		to: aMaVariableObjectBuffer objectInstSize
		do:
			[ : index |
			skeleton
				instVarAt: index
				put: (aMaVariableObjectBuffer maInstVarAt: index) ].
	^ skeleton! !

!Object class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:47'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"This is the standard-case for building a skeleton of a variable-byte-sized object."
	^ aMaByteObjectBuffer asByteObject: self! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 3/27/2006 17:03'!
maEstablishPointerReferencesUsing: aMaObjectSerializer 
	"I am currently loaded with oids of the objects that I should be referencing.  Now that objects for these oids are, themselves, materialized, I can now replace my referernces to oids wtih references to the real objects."
	self maOriginalClass isPointers 
		ifFalse: 
			["don't need to do this."
			^self].
	1 
		to: self maInstSize
		do: 
			[:instVarIndex | 
			| oid |
			oid _ self instVarAt: instVarIndex.
			oid ifNotNil: 
				["could be nil if different class def"
				"we shouldn't need to worry about transient vars here because they would have been stored as nil."
				self 
					instVarAt: instVarIndex
					put: (aMaObjectSerializer objectWithOid: oid)]]! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 1/16/2005 23:51'!
maRequiresOwnBuffer
	"Answers false if the receiver has a special oid to represent it, such as nil, true, false and other immutables do."

	^ self class maInstancesRequireOwnBuffer! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 4/10/2005 18:00'!
maSerializationClass
	"For WriteBarrier support."

	^self maOriginalClass! !

!Object methodsFor: '*ma object serialization' stamp: 'cmm 2/13/2005 21:54'!
maStreamVariablyInto: aMaVariableBuffer for: aMaObjectSerializer
	"Put the receivers instance variables (both named and indexed) into aMaVariableObjectBuffer."

	1
		to: self maInstSize
		do:
			[ : index |
			(self maIsTransient: index)
				ifFalse:
					[ aMaVariableBuffer
						maInstVarAt: index
						put: (aMaObjectSerializer oidFor: (self instVarAt: index)) ] ]! !

PackageInfo subclass: #MaObjectSerializationPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma object serialization-Info'!

!MaObjectSerializationPackageInfo class methodsFor: 'as yet unclassified' stamp: 'cmm 12/27/2008 13:29'!
packageName
	^ 'Ma object serialization'! !

!MaObjectSerializationPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2009 17:42'!
prerequisitePackageNames
	^ super prerequisitePackageNames , { 
			(MaExceptionHandlingPackageInfo packageName).
			(MaBaseAdditionsPackageInfo packageName).
			(MaTraverseObjectGraphsPackageInfo packageName).
			(MaStatisticsPackageInfo packageName).
			(MaSpecialCollectionsPackageInfo packageName)
		 }! !

!MaObjectSerializationPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2003 00:41'!
readmeText

	^'I am a general object serialization and materialization framework.  Currently, I convert objects to ByteArrays and back.  I am used by both the "Ma client server" and "Magma" packages.  I offer a lot of flexibility in the way objects are serialized and materialized, even to the way the object graphs are traversed during serialization (courtesy of "Ma object serialization").

The major class is MaObjectSerializer, see it for more information.  It utilizes a MaDefaultOidManager, a MaDefaultClassIdManager, and a MaObjectGraphTraversalStrategy to create a MaSerializedGraphBuffer, the final object that wraps the ByteArray.'! !

!True methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForTrue
! !

!ChangeSet class methodsFor: '*ma object serialization' stamp: 'cmm 8/22/2005 09:35'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"Materialize the association:  change set name -> the stream on which the change set was filed out.
	Signal the incoming chang-set notification and, if the user has written code to override the defaultAction, it will be filed in the name isn't already in use."
	| nameAndChangeSetAssociation changeSetName stream |
	nameAndChangeSetAssociation := (aMaObjectSerializer materializeGraph: aByteArray).
	changeSetName := nameAndChangeSetAssociation key.
	stream := nameAndChangeSetAssociation value.
	^ (MaIncomingChangeSetNotification signal: 'Is it ok to file-in ', changeSetName) == true "default to false if they return with a non-boolean."
		ifTrue:
			[ ChangeSorter
				newChangesFromStream: stream
				named: changeSetName ]
		ifFalse: [ ChangeSorter existingOrNewChangeSetNamed: changeSetName ]! !

!ChangeSet methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 21:43'!
maAsStorageObject
	"While we can store ChangeSets and their CompiledMethods directly, a logical representation (i.e., my fileOut) is probably better.  Therefore, we file out me to a stream and keep that along with my name.  My code will NOT be automatically filed-in on materialization."

	| stream |
	stream _ ReadWriteStream on: String new.
	self fileOutOn: stream.
	stream position: 0.
	^ self name -> stream! !

!ChangeSet methodsFor: '*ma object serialization' stamp: 'cmm 2/3/2005 17:29'!
maUsesStandardStorage
	^ false! !

!Project methodsFor: '*ma object serialization' stamp: 'cmm 2/22/2005 12:49'!
maTransientVariables
	"Don't store or traverse these variables when serializing me."
	^ super maTransientVariables, #('parentProject' 'nextProject' 'previousProject')! !

!Project methodsFor: '*ma object serialization' stamp: 'cmm 11/26/2004 15:15'!
maWantsPostMaterialization 
	^ true! !

!Project methodsFor: '*ma object serialization' stamp: 'cmm 2/11/2005 09:53'!
maWantsPreSerialization
	^ true! !

!False methodsFor: '*ma object serialization' stamp: ''!
maOid

	^MaOidCalculator oidForFalse
! !

!ContextPart methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !

!SmallInteger class methodsFor: '*ma object serialization' stamp: 'cmm 6/11/2004 13:57'!
maInstancesRequireOwnBuffer

	^ false! !

!SmallInteger class methodsFor: '*ma object serialization' stamp: 'cmm 6/2/2004 16:54'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^MaOidCalculator
		objectWithOid: aMaByteObjectBuffer oid
		ifNone: [ self error: aMaByteObjectBuffer , ' is not a buffer for a SmallInteger.' ]
! !

!PasteUpMorph class methodsFor: '*ma object serialization' stamp: 'cmm 11/23/2004 12:52'!
maMaterializeFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^ World! !

!PasteUpMorph methodsFor: '*ma object serialization' stamp: 'cmm 2/22/2005 12:49'!
maTransientVariables

	^ super maTransientVariables, #('worldState')! !

!EToyProjectHistoryMorph class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:17'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer
	"It seems these ProjectHistoryMorphs are simply image-specific things, i.e., the history of whatever projects in the current image."

	^ self new! !

!EToyProjectHistoryMorph methodsFor: '*ma object serialization' stamp: 'cmm 2/17/2005 13:55'!
maAsStorageObject 
	^ String maEmpty! !

!EToyProjectHistoryMorph methodsFor: '*ma object serialization' stamp: 'cmm 2/17/2005 13:55'!
maUsesStandardStorage

	^ false! !

!WeakSet methodsFor: '*ma object serialization' stamp: 'cmm 12/1/2004 22:55'!
maBufferInstSize

	^ self slowSize! !

!WeakSet methodsFor: '*ma object serialization' stamp: 'cmm 3/7/2005 14:43'!
maStreamVariablyInto: aMaVariableObjectBuffer for: aMaObjectSerializer
	"If a GC has happened since we set aMaVariableObjectBuffer's logicalSize then, upon materialization, it may try to load with 'garbage' oids because we load up to the number of logicalSize instVars (and the buffer would have garbage at those places).  Therefore, reset the logicalSize after populating."
	super
		maStreamVariablyInto: aMaVariableObjectBuffer
		for: aMaObjectSerializer.
	aMaVariableObjectBuffer physicalSize: (aMaVariableObjectBuffer physicalSizeFor: self)! !

!Exception methodsFor: '*ma object serialization' stamp: 'cmm 6/10/2005 11:24'!
maTransientVariables 

	^ super maTransientVariables, #( 'signalContext' 'handlerContext' 'outerContext' )! !

!MethodContext class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:15'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	^ (aMaObjectSerializer materializeGraph: aByteArray) asMethodContext! !

!MethodContext methodsFor: '*ma object serialization' stamp: 'cmm 11/10/2004 12:02'!
maAsStorageObject

	^ MaMethodContextStorage newFor: self! !

!TranscriptStream class methodsFor: '*ma object serialization' stamp: 'cmm 5/2/2005 10:16'!
maMaterializeFromGraph: aByteArray using: aMaObjectSerializer

	^ Transcript! !

!TranscriptStream methodsFor: '*ma object serialization' stamp: 'cmm 12/19/2002 23:13'!
maAsStorageObject
	"We don't even need to store the name of this global.  It's class
	gives it away."

	^String maEmpty! !

!TranscriptStream methodsFor: '*ma object serialization' stamp: 'cmm 11/29/2004 11:01'!
maUsesStandardStorage

	^ false! !
MaObjectBuffer initialize!
MaSerializedGraphBuffer initialize!
